<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
    <style type="text/css">


H3 { 
 	font-family : Arial, Helvetica, sans-serif;
	font-weight : 600;
	font-size : 14px;
	color: #336699;		}

a: {
		color: #336699;
     	text-decoration: underline; }
 
 OL {
  	font-family : Arial, Helvetica, sans-serif;
	font-size : 12px;	}
	
 </style>
</head>
<body style="font-family: Times New Roman">
    <form id="form1" runat="server">
    <div>
        <span style="font-size: 14pt"><strong>ASP NET Profiling with PurifyPlus</strong></span>
        <br />
    </div>
        <p><b>Profiling Web applications hosted by IIS 6</b></p>
    <p><span>
            ASP.NET code is monitored by using the PurifyPlus ASP.NET profiling monitor, AspNetMon.exe. 
            This monitor enables profiling for managed code running in the context of ASP.NET or as a Web Service. 
        </span></p>
        <p><span style="font-size: 12pt">
            The monitor is implemented as a Windows system tray icon.
            To start the monitor, run AspNetMon.exe (typically found in C:\Program Files\Rational\Common).
            After the monitor is started, a small traffic light icon appears in the system tray
            area of the Windows taskbar. 
        </span></p>
        <p> <img src="img/AspMonSysTray.gif" style="font-size: 12pt" />&nbsp;</p>
        <p><span style="font-size: 12pt">
            The red light indicates profiling is disabled for all
            PurifyPlus components. The green light indicates profiling is enabled for one of
            the components (Purify, Quantify, or Coverage). Hover the mouse cursor over the
            monitor icon to view the current monitor status (enabled or disabled), and the component
            name for which profiling is enabled (Purify, Quantify, or Coverage). 
        </span></p>
        <p><span style="font-size: 12pt">
            To change the monitor status, right-click the monitor icon in the system tray. 
            A popup menu displays the following choices: 
        </span></p>
        <p>
            <span style="font-size: 12pt">
                <img src="img/AspNetMenu.gif" /></span>&nbsp;</p>
        <p>
            <span style="font-size: 12pt">
            Choose "ASP.NET Monitoring Disabled" to disable profiling
            for all PurifyPlus components, or choose "Enable ASP.NET Monitoring for &lt;componentName&gt;"
            to enable profiling for one of the PurifyPlus components. </span>
        </p>
        <p><span style="font-size: 12pt">
            Once started, the monitor will continue to run until the
            operating system is rebooted. To start the monitor automatically, place a shortcut
            to AspNetMon.exe in the startup folder of the All Users &gt; Start Menu. 
        </span></p>
        <p><span style="font-size: 12pt">
            In order to obtain data for your ASP.NET application,
            you need to either take a snapshot from the Purify (or Quantify or PureCoverage)
            GUI or disable the monitor as described above.
        </span></p>
        <p class="rGlossary-Text" style="margin-top: 0px; margin-bottom: 0px">
            <span style="font-size: 12pt">Notes:</span></p>
            <div>
                <ul>
                    <li> <span>
                        ASP.NET implementation on Windows XP and Windows 2003 Server is different. On Windows
                        XP managed ASPX code is hosted by so called "ASP Net Worker Process" (aspnet_wp.exe),
                        while on Windows 2003 managed code is hosted by the "WWW Worker Process" (w3wp.exe).
                        There is not much difference between these two worker processes except for the name.
                        We support both.&nbsp;
                    </span> </li>
                    <li> <span>
                        It is better to start AspNetMon.exe from an account with administrative privileges.
                        Otherwise it becomes subject to multiple security restrictions.</span></li>
                    <li> <span>
                        There is no remote mode for PurifyPlus. It should be properly installed and running
                        on the server machine. Usually monitoring is enabled by AspNetMon.exe being started on the server machine.&nbsp;</span></li>
                    <li> <span>
                        It is a good idea to limit the information collected by using prefiltering. 
                        In the Default Settings or Executable Settings dialog click on the
                        PowerCheck tab. Then click the Configure button in the Java/Managed box. You will
                        see the prefiltering dialog that controls which classes should be monitored. You
                        may exclude classes you don't want to monitor or just select classes of interest.
                        In your case you may choose 'selected classes' and include the namespace implemented
                        in the target assembly in the target pattern.
                    </span></li>
                    <li> <span>
                        When profiling an ASP.NET 2.0 application, make sure you run the server-side code in "High Security" 
                        or "Isolated" mode. To switch to this mode, start the system management console,
                        select "Services and Applications/Web Sites/Default Web Site" or any specific web site you want to configure, 
                        right click on it and select "Properties" in the context menu. 
                        In the "Web site properties" dialog select the "Home Directory" tab. Click
                        on the "Application Protection" drop box and select "High (isolated)". Click "OK"
                        and restart your IIS server. This change has to be done only once. After that you
                        should be able to use AspNetMon.exe to enable/disable profiling of ASP.NET applications.
                    </span></li>
                </ul>
            </div>
        <p>
                <b>Profiling Web applications hosted by IIS 7 and up</b></p>
    <p>
        The worker process implementation and recycling on the ASP.NET 3.0 platform 
        (with IIS 7.0) underwent significant changes. As a result, the AspNetMon utility 
        doesnt currently support ASP.NET 3.0 and above. To profile ASP.NET components 
        on a Windows Vista machine, you will have to enable profiling by reconfiguring 
        IIS. There are two ways to enable ASP.NET profiling:
    </p>
    <ol>
        <li>Create a dedicated user context for profiling. /li>
        <li>Enable it globally, for the entire operating system. </li>
    </ol>
    Later, both methods will be described. First some prerequisites:
    <ol>
        <li>PurifyPlus must be properly installed on the computer hosting the ASP.NET Web 
            server (IIS). There is no remote profiling of any kind. </li>
        <li>Only 32 bit operating systems are supported. Hosting 32 bit ASP.NET components 
            on a 64 bit operating system is not currently supported </li>
        <li>IIS should be configured to host ASP.NET components. Steps for configuring IIS 
            are beyond the scope of this document. </li>
    </ol>
    Dot Net profiling in general is turned on and off by defining certain 
    environment variables in the process hosting the Dot Net application. It is 
    important to have these variables defined before the Dot Net Execution Engine 
    (MsCorEE.DLL) is loaded and initialized. In the case of ASP.NET the hosting 
    process is typically W3WP.EXE. Here are the required environment variables.
    <ul>
        <li>COR_ENABLE_PROFILING=1 When this variable is set to 0 or not present the 
            profiling is disabled. </li>
        <li>COR_PROFILER= {679367E3-FC39-11D3-8A11-00105A2A1490} The GUID defined in this 
            variable belongs to the PurifyPlus Dot Net profiling agent implemented in 
            BciEngCor.DLL </li>
        <li>PURE_MONITOR_ENABLE=&lt;product&gt; Where (depending on the kind of profiling you 
            need) &lt;product&gt; is one of the following:
            <ol>
                <li>Purify </li>
                <li>Quantify </li>
                <li>Coverage </li>
            </ol>
        </li>
        <li>PURE_MONITOR_TARGET_PATTERN=W3WP Optional. Should be set if you want to limit 
            the profiling to ASP.NET worker processes only. </li>
        <li>PURE_USE_GLOBAL_NAMESPACE=1 This variable is only necessary when you start 
            PurifyPlus from a remote terminal session. </li>
    </ul>
    <h5>
        How to enable profiling in a dedicated user context.</h5>
    To take advantage of this approach, you should first create a user account that 
    will be used specifically for hosting the worker processes that you want to 
    profile. Use the computer management console (compmgmt) to add a new user to the 
    system. You can call this user Profiler. Remember the user name and password, 
    as you will need it later to configure IIS. Below are the step-by-step 
    instructions:
    <ol>
        <li>Create the new user account you will be using for profiling. </li>
        <li>Log into the profiling specific account and add variables from table 1 to the 
            USER environment. </li>
        <li>Open the IIS administration console. Via a command prompt type compmgmt and in 
            the navigation pane on the left select the Services and Applications \ IIS 
            Manager. </li>
        <li>In the Connections view select Application Pools. </li>
        <li>In the Actions click Add Application Pool. Give it a name you want (e.g. 
            Profiling Pool). </li>
        <li>Select the newly created pool and in the Actions click Advanced Settings.
        </li>
        <li>Scroll down to the Process Model And select SpecificUser in the Identity 
            field. </li>
        <li>Fill in the User Name and Password fields using the information for the 
            profiling specific user you created at step 1. </li>
        <li>Start the appropriate PurifyPlus UI (i.e. Purify, Quantify or PureCoverage).
        </li>
        <li>In the connection View open the Web Sites subtree. </li>
        <li>Select the web site you want to profile. </li>
        <li>In the Actions view click Basic Settings </li>
        <li>Click the Select button next to the application pool. </li>
        <li>To enable profiling select the profiling specific pool you created in steps 5-8. 
            To disable profiling, select any other application pool. </li>
        <li>Open the Web site you want to profile in a browser. </li>
        <li>To finalize profiling. Select the Application pools in the connections, click 
            on the pool you are using for profiling and in the Actions view click 
            Recycle. </li>
    </ol>
    <p>
        Follow steps 11-14 each time you want to enable or disable profiling.
    </p>
    <h5>
        How to enable profiling at the global system level</h5>
    <ol>
        <li>Add the environment variables listed in the table 1 to the SYSTEM environment.
        </li>
        <li>Reboot the operating system. </li>
        <li>Start the appropriate PurifyPlus UI (i.e. Purify, Quantify or PureCoverage).
        </li>
        <li>Open the ASP.NET page you want to profile in a browser. </li>
    </ol>
    <p>
        If all steps were followed properly, you should see a new profiling session in 
        the PurifyPlus UI. <a name="support info"></a>
    </p>
    <p>
                &nbsp;</p>
    <p>
                <span style="font-size: 12pt"><strong>(C) Copyright IBM Corporation 1992, 2006. </strong>
                </span>
        </p>
    </form>
</body>
</html>
