using System;
using System.Drawing;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using Rational;

public partial class _Default : System.Web.UI.Page 
{
    SessionData sdat;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session.IsNewSession)
        {
            sdat = new SessionData();
            Session.Add("SessionData", sdat);
        }
        else
        {
            sdat = (SessionData)Session["SessionData"];
        }
        MultiViewHelp.SetActiveView(ViewHelpLink);
        CheckBoxPureApi.Enabled = PureAPI.IsRunning() == 1 ? true : false;
    }

    protected void ButtonProcess_Click(object sender, EventArgs e)
    {
        if (FileUpload1.HasFile)
        {
            /*
             * Alternative implementation based on the temporary file
            string strTempFile = string.Format("\\Inetpub\\Uploads\\Temp{0}.dat", Session.SessionID);
            FileUpload1.SaveAs(strTempFile);
            sdat.FileName = FileUpload1.FileName;
            sdat.InStream = new FileStream(strTempFile, FileMode.Open);
            */

            // Implementation based on the memory stream
            if (FileUpload1.FileBytes == null)
                throw new Exception("No input file");
            sdat.InStream = new MemoryStream(FileUpload1.FileBytes);
            LabelMsg.ForeColor = Color.Blue;
            LabelMsg.Text = FileUpload1.FileName;
        }
        try
        {
            sdat.bFixPerformance = CheckBoxFixPerf.Checked;
            sdat.bFixLeaks = CheckBoxFixLeaks.Checked;
            sdat.bUsePureApi = CheckBoxPureApi.Checked;
            sdat.ProcessData();
            sdat.ShowData(TableResults);
        }
        catch (WordCount.WordCountException ex)
        {
            LabelMsg.ForeColor = Color.Red;
            LabelMsg.Text = ex.Message;
        }
    }
    protected void ButtonWords_Click(object sender, EventArgs e)
    {
        sdat.SortByWords();
        sdat.ShowData(TableResults);
    }
    protected void ButtonCounts_Click(object sender, EventArgs e)
    {
        sdat.SortByFreq();
        sdat.ShowData(TableResults);
    }
    protected void LinkButtonHelp_Click(object sender, EventArgs e)
    {
        MultiViewHelp.SetActiveView(ViewHelpPage);
    }
    protected void ButtonCloseHelp_Click(object sender, EventArgs e)
    {
        MultiViewHelp.SetActiveView(ViewHelpLink);
    }
}
