using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Text;
using System.Resources;

namespace ManagedServiceSample
{
    public partial class ManagedService : ServiceBase
    {

        private TcpChannel srvChannel = new TcpChannel(8085);
        private string strRemote = "ibm.rational.purifyplus.managedservicesample";

        public ManagedService()
        {
            InitializeComponent();
        }

        protected override void OnStart(string[] args)
        {
            try
            {
                ChannelServices.RegisterChannel(srvChannel, false /*ensureSecurity*/);
                RemotingConfiguration.RegisterWellKnownServiceType(typeof(RemoteService), strRemote, WellKnownObjectMode.SingleCall);
                EventLog.WriteEntry("Managed Service Sample Started", EventLogEntryType.Information);
            }
            catch (Exception ex)
            {
                EventLog.WriteEntry("Managed Service Sample failed to start\n" + ex.ToString(), EventLogEntryType.Error);
            }

        }

        protected override void OnStop()
        {
            EventLog.WriteEntry("Managed Service Sample Stoped", EventLogEntryType.Information);
        }

        protected override void OnCustomCommand(int command)
        {
            switch(command)
            {
                case 1:
                    break;
                case 2:
                    break;
            }
        }

    }
}
