using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;
using System.ServiceProcess;

namespace ManagedServiceSample
{
    [RunInstaller(true)]
    public partial class ManagedServiceInstaller : Installer
    {
        private ServiceInstaller serviceInstaller;
        private ServiceProcessInstaller processInstaller;

        public ManagedServiceInstaller()
        {
            InitializeComponent();
			processInstaller = new ServiceProcessInstaller();
			serviceInstaller = new ServiceInstaller();

			// Service will run under system account
			processInstaller.Account = ServiceAccount.LocalSystem;

			// Service will have Start Type of Manual
			serviceInstaller.StartType = ServiceStartMode.Manual;
			serviceInstaller.ServiceName = "ManagedService";
            serviceInstaller.DisplayName = "Managed Service Sample";
            serviceInstaller.Description = "Service Impemented with VS2005 C#";
            
			Installers.Add(serviceInstaller);
			Installers.Add(processInstaller);
        }
    }
}