using System;
using System.Threading;
using System.Collections.Generic;
using System.Text;

namespace ManagedServiceSample
{
    internal class PerformanceTest
    {
        public PerformanceTest(int i_nMillis)
        {
            m_nMillis = i_nMillis;
        }

        public void Run()
        {
            
            Thread.Sleep(m_nMillis);
        }

        private int m_nMillis;
    }

    public class RemoteService : MarshalByRefObject 
    {
        private int m_nInst = 0;
        static LinkedList<string> m_LeakRoot = new LinkedList<string>();
        static int m_nLeakCount = 0;
        static int m_nLeakSize = 0;

        public RemoteService()
        {
            m_nInst++;
        }

        ~RemoteService()
        {
            m_nInst--;
        }

        public void TestPerformance(int i_nThreads, int i_nCycles)
        {
            while (i_nThreads-- > 0)
            {
                PerformanceTest t = new PerformanceTest(i_nCycles);
                Thread thr = new Thread(new ThreadStart(t.Run));
                thr.Start();
            }
        }

        public void TestMemory(int i_nLeaks, int i_nLeakSize)
        {
            m_nLeakCount += i_nLeaks;
            while (i_nLeaks-- > 0)
            {
                string s = new string('*', i_nLeakSize);
                m_nLeakSize += i_nLeakSize;
                m_LeakRoot.AddLast(s);
            }

        }

        public String Status()
        {
            return String.Format("Managed Service. Activation count {0}, Leaks: {1}, Leaked Size {2}", 
                m_nInst, m_nLeakCount, m_nLeakSize);
        }

    }
}
