// ClientInterface.h : Declaration of the CClientInterface

#pragma once
#include "resource.h"       // main symbols

#include "SampleService_i.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CClientInterface

class ATL_NO_VTABLE CClientInterface :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CClientInterface, &CLSID_ClientInterface>,
	public IClientInterface
{
public:
	CClientInterface()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CLIENTINTERFACE)


BEGIN_COM_MAP(CClientInterface)
	COM_INTERFACE_ENTRY(IClientInterface)
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:

	STDMETHOD(Control)(enControl_t i_ulCode);
	STDMETHOD(GetEnv)(BSTR i_bstrName, BSTR* r_pbstrVal);
	STDMETHOD(IsInstrumented)(enInstrumented_t* r_enInstrumented);

private:

	void DoABR();
	void DoUMR();
	void DoMLK();
};

OBJECT_ENTRY_AUTO(__uuidof(ClientInterface), CClientInterface)
