//==============================================================================
// SampleService.cpp
//
// PurifyPlus Native Service Sample: SampleService
//
//
// Service application.
// Use the service manager or net SampleService commands
// to start and stop this service.
//
// To register service:
//	SampleService /-service
// To unregister service:
//  SampleService -unregserver
//
// DCOM Interface ProgID: SampleService.ClientInterface
//==============================================================================


#include "stdafx.h"
#include "resource.h"
#include "SampleService_i.h"

#include <stdio.h>

//------------------------------------------------------------------------------
// Constructor
//
class CSampleServiceModule : public CAtlServiceModuleT< CSampleServiceModule, IDS_SERVICENAME >
{
public :
	DECLARE_LIBID(LIBID_SampleServiceLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_SAMPLESERVICE, "{29BCFC62-E12A-464B-9BA0-7E9DDDA49662}")
	HRESULT InitializeSecurity() throw()
	{
		// Initialize security:
		// Suggested - PKT Level Authentication, 
		// Impersonation Level of RPC_C_IMP_LEVEL_IDENTIFY 
		//
		// Note: To be able to communicate with this service from non-priveleged accounts,
		// appropriate non-null security descriptor should be created.
		//
		HRESULT hr;
		hr = CoInitializeSecurity( 0, -1, 0, 0, 
			RPC_C_AUTHN_LEVEL_NONE, 
			RPC_C_IMP_LEVEL_IDENTIFY, 0, 0, 0 );
		return S_OK;
	}
};

// The instance of the service module
CSampleServiceModule _AtlModule;


//------------------------------------------------------------------------------
// Main
extern "C" int WINAPI _tWinMain(HINSTANCE /*hInstance*/, HINSTANCE /*hPrevInstance*/, 
                                LPTSTR /*lpCmdLine*/, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}

//= End of SampleService.cpp ===================================================
