////////////////////////////////////////////////////////////////////////////////
// BadActX ActiveX Demonstration Program For Purify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
// Venki Muthanna and John Birchfield
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// BadActXATL.cpp : Implementation of CMyBadActXATL

#include "stdafx.h"
#include "BadActX.h"		// for CLSID_BadActXATL,IID_IMyBadActXATL,LIBID_BADACTXLib
#include "BadActXATL.h"		// for class CMyBadActXATL
#include <iostream>			// for class cerr
#include <winreg.h>				// for RegOpenKeyEx()
#include <OBJIDL.H>				// for IMalloc_Release()
#include <process.h>			// for _beginthread()
#include "pure.h"				// for PurifyIsRunning()

using namespace std;

#define MAX_MSG_SIZE 256

/////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL
CMyBadActXATL::CMyBadActXATL()
{
	// must be here instead of in CBadActXApp::InitInstance()
	// or TRACE errors and ASSERTS will shortly follow!
	AfxEnableControlContainer();
	//**************************************************************
	// There must be a better way to resize the whole damn thing!
	// overriding SetExtent as Tom Armstrong suggested in www.widgetware.com
	// FAQ's did not work
	//STDMETHOD(SetExtent)(DWORD dwDrawAspect, SIZEL *psizel)
	//{
	//	ATLTRACE(_T("SetExtent sizing control to 480 x 295\n"));
	//	psizel->cx = 480;
	//	psizel->cy = 295;
	//	return IOleObjectImpl<CNoteCtl>::SetExtent(dwDrawAspect, psizel);
	//}
	// Soooooo.....
	// Allow a user to resize
	m_bAutoSize = FALSE;
	SIZEL sizeInPix;
	///AtlHiMetricToPixel(&m_sizeExtent, &sizeInPix);	// returns 240 by 240 pixels
	// Set the initial size
	sizeInPix.cx = 480;
	sizeInPix.cy = 295;
	AtlPixelToHiMetric(&sizeInPix, &m_sizeExtent);
	// Make sure the natural extent is the correct size too
	m_sizeNatural = m_sizeExtent;
	//**************************************************************
	// HACK to get CString str.LoadString() to work!
	AfxSetResourceHandle(_Module.GetResourceInstance());
	m_MSFlexGrid = NULL;
}


/////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL
CMyBadActXATL::~CMyBadActXATL()
{
}


HRESULT CMyBadActXATL::OnDraw(ATL_DRAWINFO& di)
{
	RECT& rc = *(RECT*)di.prcBounds;
	Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
	if (NULL!=m_hWnd &&
		NULL!=m_MSFlexGrid &&
		NULL!=m_MSFlexGrid->m_hWnd)
	{
		// HACK to get grid to redraw properly in IE 4.0
		m_MSFlexGrid->Refresh();
	}
	return S_OK;
}

HWND CMyBadActXATL::CreateControlWindow(HWND hWndParent, RECT& rcPos)
{
	if (m_hWnd)
	{
		//********************************************************************
		// NOTE: PROTECTION against multiple invocations if and when IE 4.0
		// changes back it behavior to be consistent with tstcon32.exe and IE 3.02
		//********************************************************************
		return m_hWnd;
	}
	//********************************************************************************
	// should be but does not link: 
	// HWND hwnd = CComControlBase::CreateControlWindow(hWndParent, rcPos);
	// IS and does compile and link:
	CMyBadActXATL* pT = static_cast<CMyBadActXATL*>(this);
	HWND hWnd =  pT->Create(hWndParent, rcPos, TEXT("MyBadActXATL"));
	// shamelessly stolen from \devstudio\vc\atl\include\atlctl.cpp
	//********************************************************************************

	m_MSFlexGrid = new CMyGridCtrl;
	// MAGIC: must attach a private window to interface with the
	// automatically generated public API interface files generated by
	// the class wizzard for the Microsoft Flex Grid control
	m_PvtWnd.Attach(hWnd);
	TCHAR msg[MAX_MSG_SIZE];
	::LoadString(_Module.GetResourceInstance(),	IDS_MSG_DEMONSTRATION, msg, MAX_MSG_SIZE);

	// HACK to prevent tstcon32.exe from asserting in atlwin.cpp line 454
	CRect rect(0, 0, rcPos.right-rcPos.left, rcPos.bottom-rcPos.top);
	m_MSFlexGrid->Create(_T(""),
						 WS_CHILD | WS_VISIBLE,
						 rect,
						 &m_PvtWnd,
						 IDC_MSFLEXGRID);

	m_MSFlexGrid->SetRows(31);

	long width;
	width = m_MSFlexGrid->GetColWidth(0);
	m_MSFlexGrid->SetColWidth(0, width*2);


	width = m_MSFlexGrid->GetColWidth(0);
	m_MSFlexGrid->SetColWidth(1, width*2);


	m_MSFlexGrid->SetCol(0);
	m_MSFlexGrid->SetRow(0);
	::LoadString(_Module.GetResourceInstance(),	IDS_MSG_TYPE, msg, MAX_MSG_SIZE);
	m_MSFlexGrid->SetText(msg);

	m_MSFlexGrid->SetCol(1);
	m_MSFlexGrid->SetRow(0);
	::LoadString(_Module.GetResourceInstance(),	IDS_MSG_DESCRIPTION, msg, MAX_MSG_SIZE);
	m_MSFlexGrid->SetText(msg);

	// initialize the purify m_MSFlexGrid
	COLORREF red	= RGB(255, 0, 0);
	COLORREF blue	= RGB(0, 255, 255);
	COLORREF yellow = RGB(255, 255, 0);

	AddToBadThingsList(abr,			red,	IDS_ABR);
	AddToBadThingsList(abw,			red,	IDS_ABW);
	AddToBadThingsList(abwl,		red,	IDS_ABWL);
	AddToBadThingsList(bsr,			red,	IDS_BSR);
	AddToBadThingsList(bsw,			red,	IDS_BSW);
	AddToBadThingsList(exc,			blue,	IDS_EXC);
	AddToBadThingsList(exh,			blue,	IDS_EXH);
	AddToBadThingsList(exi,			blue,	IDS_EXI);
	AddToBadThingsList(exu,			blue,	IDS_EXU);
	AddToBadThingsList(ffm,			red,	IDS_FFM);
	AddToBadThingsList(fim,			red,	IDS_FIM);
	AddToBadThingsList(fmm,			red,	IDS_FMM);
	AddToBadThingsList(fmr,			red,	IDS_FMR);
	AddToBadThingsList(fmw,			red,	IDS_FMW);
	AddToBadThingsList(fmwl,		red,	IDS_FMWL);
	AddToBadThingsList(ivh,			yellow,	IDS_IVH);			// HAN
	AddToBadThingsList(hwnds_inuse, blue,	IDS_HNDS_INUSE);	// HIU
	AddToBadThingsList(ilk,			yellow,	IDS_ILK);
	AddToBadThingsList(ipr,			red,	IDS_IPR);
	AddToBadThingsList(ipw,			red,	IDS_IPW);
	AddToBadThingsList(maf,			blue,	IDS_MAF);
	AddToBadThingsList(miu,			blue,	IDS_MIU);
	AddToBadThingsList(mlk,			yellow,	IDS_MLK);
	AddToBadThingsList(mpk,			blue,	IDS_MPK);
	AddToBadThingsList(npr,			red,	IDS_NPR);
	AddToBadThingsList(npw,			red,	IDS_NPW);
	AddToBadThingsList(ods,			blue,	IDS_ODS);
	AddToBadThingsList(par,			yellow,	IDS_PAR);
	AddToBadThingsList(umc,			yellow,	IDS_UMC);
	AddToBadThingsList(umr,			yellow,	IDS_UMR);
	// select the first item in the list,
	// note: the list is zero index based
	m_MSFlexGrid->SetFocus();

	// control how the operating system handles several types of
	// serious errors since this program creates them intentionally!
	SetErrorMode(SEM_FAILCRITICALERRORS | 
				 SEM_NOALIGNMENTFAULTEXCEPT |	// WINNT only
				 SEM_NOGPFAULTERRORBOX);

	m_MSFlexGrid->ShowWindow(SW_NORMAL);
	return hWnd;
}

HRESULT CMyBadActXATL::InPlaceActivate(LONG iVerb, const RECT* prcPosRect)
{
	HRESULT hr;
	SIZEL size = {prcPosRect->right - prcPosRect->left, prcPosRect->bottom - prcPosRect->top};
	RECT rect = {0, 0, size.cx, size.cy};

	hr = CComControlBase::InPlaceActivate(iVerb, &rect);
	ATLTRACE(_T("InPlaceDeactivate\n"));
	//********************************************************************
	// NOTE: HACK on IE 3.02 and tstcon32.exe InPlaceActive() will call
	// CreateControlWindow() which we have overwritten. On IE 4.0, this does
	// not occur?!
	if (!m_spInPlaceSite)
		return hr;

	HWND hWndParent;
	if (S_OK==m_spInPlaceSite->GetWindow(&hWndParent))
	{
		RECT rcPos = *prcPosRect;
		CreateControlWindow(hWndParent, rcPos);
	}
	//********************************************************************
	return hr;
}

STDMETHODIMP CMyBadActXATL::InPlaceDeactivate(void)
{
	ATLTRACE(_T("InPlaceDeactivate\n"));

	if (NULL!=m_hWnd)
	{
		_ASSERTE(::IsWindow(m_hWnd));
		// must detach private window or access violation will result
		// during destruction of this object.
		m_PvtWnd.Detach();
	}
	return IOleInPlaceObjectWindowlessImpl<CMyBadActXATL>::InPlaceDeactivate();
}

//*********************************************************************************
// Having trouble implementing IObjectSafety. 
// IE keeps telling me that my controls isn't safe. Why?
// Below is some code that I got from the ATL list 
// (Thanks to philip.lee@MULTITHREAD.CO.UK) via Tom Armstrong

// IObjectSafety implementation
STDMETHODIMP CMyBadActXATL::GetInterfaceSafetyOptions( REFIID riid, DWORD *pdwSupportedOptions, DWORD *pdwEnabledOptions )

{
	UNREFERENCED_PARAMETER(riid);
	ATLTRACE(_T("CMyBadActXATL::GetInterfaceSafetyOptions()\n"));

	*pdwSupportedOptions = INTERFACESAFE_FOR_UNTRUSTED_CALLER |
						 INTERFACESAFE_FOR_UNTRUSTED_DATA;
	*pdwEnabledOptions = *pdwSupportedOptions;
	return S_OK;
}

STDMETHODIMP CMyBadActXATL::SetInterfaceSafetyOptions(REFIID riid, DWORD dwOptionSetMask, DWORD dwEnabledOptions)
{
	UNREFERENCED_PARAMETER(riid);
	UNREFERENCED_PARAMETER(dwOptionSetMask);
	UNREFERENCED_PARAMETER(dwEnabledOptions);
	ATLTRACE(_T("CMyBadActXATL::SetInterfaceSafetyOptions\n"));
	return S_OK;
}
//*********************************************************************************

/////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::OnSelChangeBadThings - 
//									
LRESULT CMyBadActXATL::OnSelChangeMsFlexGrid(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	UNREFERENCED_PARAMETER(uMsg);
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
	bHandled = TRUE;
	long row = m_MSFlexGrid->GetRowSel();
	m_CurSelRow = row;

	return 1;
}


LRESULT CMyBadActXATL::OnClickMsFlexGrid(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) 
{
	// update the help topic explaining the bug that Purify can detect
	OnSelChangeMsFlexGrid(uMsg, wParam, lParam, bHandled);
	OnDblClickMsFlexGrid(uMsg, wParam, lParam, bHandled);
	return 1;
}

LRESULT CMyBadActXATL::OnDblClickMsFlexGrid(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) 
{
	// update the help topic explaining the bug that Purify can detect
	OnSelChangeMsFlexGrid(uMsg, wParam, lParam, bHandled);
	// the selection has changed
	// get the selected item from the purify bad thing list,
	// note: the list is zero index based

	// Token-Pasting Operator (##) The double-number-sign or "token-pasting"
	// operator (##), permits separate tokens to be joined into a single 
	// token. If a formal parameter in a macro definition is preceded or 
	// followed by the token-pasting operator, the formal parameter is immediately 
	// replaced by the unexpanded actual argument. Macro expansion is not  
	// performed on the argument prior to replacement. Then, each occurrence of the 
	// token-pasting operator in token-string is removed, and the tokens preceding
	// and following it are concatenated. The resulting token must be a valid token. 
	// If it is, the token is scanned for possible replacement if it represents a
	// macro name. The identifier represents the name by which the concatenated 
	// tokens will be known in the program before replacement. Each token
	// represents a token defined elsewhere, either within the program or on the 
	// compiler command line. White space preceding or following the operator is
	// optional.
	#define INVOKE_MEMORY_ERROR( i, x ) case i: {x##(); break;}

    switch (m_CurSelRow)
    {
		INVOKE_MEMORY_ERROR(abr,		ABR);
        INVOKE_MEMORY_ERROR(abw,		ABW);
        INVOKE_MEMORY_ERROR(abwl,		ABWL);
		INVOKE_MEMORY_ERROR(bsr,		BSR);
		INVOKE_MEMORY_ERROR(bsw,		BSW);
		INVOKE_MEMORY_ERROR(exc,		EXC);
		INVOKE_MEMORY_ERROR(exh,		EXH);
		INVOKE_MEMORY_ERROR(exi,		EXI);
		INVOKE_MEMORY_ERROR(exu,		EXU);
		INVOKE_MEMORY_ERROR(ffm,		FFM);
		INVOKE_MEMORY_ERROR(fim,		FIM);
		INVOKE_MEMORY_ERROR(fmm,		FMM);
		INVOKE_MEMORY_ERROR(fmr,		FMR);
		INVOKE_MEMORY_ERROR(fmw,		FMW);
		INVOKE_MEMORY_ERROR(fmwl,		FMWL);
		INVOKE_MEMORY_ERROR(ivh,		IVH);			// HAN
		INVOKE_MEMORY_ERROR(hwnds_inuse, HNDS_INUSE);	// HIU
		INVOKE_MEMORY_ERROR(ilk,		ILK);
		INVOKE_MEMORY_ERROR(ipr,		IPR);
		INVOKE_MEMORY_ERROR(ipw,		IPW);
		INVOKE_MEMORY_ERROR(maf,		MAF);
		INVOKE_MEMORY_ERROR(miu,		MIU);
		INVOKE_MEMORY_ERROR(mlk,		MLK);
		INVOKE_MEMORY_ERROR(mpk,		MPK);
		INVOKE_MEMORY_ERROR(npr,		NPR);
		INVOKE_MEMORY_ERROR(npw,		NPW);
		INVOKE_MEMORY_ERROR(ods,		ODS);
		INVOKE_MEMORY_ERROR(par,		PAR);
		INVOKE_MEMORY_ERROR(umc,		UMC);
		INVOKE_MEMORY_ERROR(umr,		UMR);
		default: { break; }
	}
	return 1;
}

/////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::AddToBadThingsList - Helper function to set all of the
//									bad thing list items
void CMyBadActXATL::AddToBadThingsList(const UINT row, 
									   const COLORREF color,
									   const UINT resourceId)
{
	CString message;
	message.LoadString(resourceId);
	int indx = message.Find(' ');
	CString messageType = message.Left(indx);
	CString messageDescription = message.Mid(indx+1);

	m_MSFlexGrid->SetCol(0);
	m_MSFlexGrid->SetRow(row);
	m_MSFlexGrid->SetText(messageType);
	m_MSFlexGrid->SetCellBackColor(color);

	m_MSFlexGrid->SetCol(1);
	m_MSFlexGrid->SetRow(row);
	m_MSFlexGrid->SetText(messageDescription);

	messageType.Empty();
	messageDescription.Empty();
}

const int CMyBadActXATL::WarnUser() const
{
	TCHAR msg[MAX_MSG_SIZE];
	::LoadString(_Module.GetResourceInstance(),	IDS_DANGER_MSG,	msg, MAX_MSG_SIZE);
	TCHAR prodMsg[MAX_MSG_SIZE];
	::LoadString(_Module.GetResourceInstance(), IDS_PROD_MSG, prodMsg, MAX_MSG_SIZE);
	return ::MessageBox(m_hWndParent, msg, prodMsg, MB_OKCANCEL);
}

void CMyBadActXATL::InformUser(const UINT msgId) const
{
	TCHAR msg[MAX_MSG_SIZE];
	::LoadString(_Module.GetResourceInstance(),	msgId,	msg, MAX_MSG_SIZE);
	TCHAR prodMsg[MAX_MSG_SIZE];
	::LoadString(_Module.GetResourceInstance(), IDS_PROD_MSG, prodMsg, MAX_MSG_SIZE);
	::MessageBox(m_hWndParent, msg, prodMsg, MB_OK);
}

//----------------------------------------------------------------------------
// CMyBadActXCtrl message handlers
/////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::ABR  Array Bounds Read Error
void CMyBadActXATL::ABR(void) const
{
	int *ptr = new int[2];          // Allocate memory for 2 ints
    ptr[0] = 0;
    ptr[1] = 1;
    for (int i=0; i <= 2; i++) {    // Bug: print 3 ints, not 2
        // ABR when i is 2
        cerr << "ptr[" << i << "] == " << ptr[i] << '\n';
    }
    delete[] ptr;
}


////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::ABW  Array Bounds Write Error
void CMyBadActXATL::ABW(void) const
{
	__try
	{
		if (IDCANCEL==WarnUser()) 
			return;
		int *ptr = new int[2];          // Allocate memory for 2 ints
		for (int i=0; i <= 2; i++) {    // Bug: manipulate 3 ints, not 2
			// ABW then ABR when i is 2
			ptr[i] = i;
			cerr << "ptr[" << i << "] == " << ptr[i] << '\n';
		}
		delete[] ptr;
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::ABWL  Late Detect Array Bounds Write Error
void CMyBadActXATL::ABWL(void) const
{
	__try
	{
		InformUser(IDS_ABWL_MSG);
		if (IDCANCEL==WarnUser()) 
			return;
		int *ptr = new int[2];          // Allocate memory for 2 ints
		for (int i=0; i <= 2; i++) {    // Bug: manipulate 3 ints, not 2
			ptr[i] = i;
			cerr << "ptr[" << i << "] == " << ptr[i] << '\n';
		}
		delete[] ptr;  //ABWL: due to write when i was 2
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
#define A_LOT 256
static int *
setup_values(void)
{
    int values[A_LOT];    // Bug: This should be 'static', not automatic
    for (int i=0; i < A_LOT; i++) {
        values[i] = i;
    }
    return(values);       // Bug: returning a value which vanishes as we return
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::BSR  Beyond Stack Read
void CMyBadActXATL::BSR(void) const
{
    int *values;
    values = setup_values();
    for (int i=0; i < A_LOT; i++) {
        // BSR: the values from "setup_values" are no longer alive on the stack

        cerr << "element #" << i << " is " << values[i] << '\n';
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::BSW  Beyond Stack Write
void CMyBadActXATL::BSW(void) const
{    
	if (IDCANCEL==WarnUser()) 
		return;
	int *values;
    values = setup_values();
    for (int i=0; i < A_LOT; i++) {
        // BSR and BSW: updating values which are no longer alive on the stack

        values[i] *= i;
        cerr << "element #" << i << " is " << values[i] << '\n';
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::EXC  Continued Exception
void CMyBadActXATL::EXC(void) const
{
    int  first = 1;
    char *ptr = NULL;
    __try {
        *ptr = NULL;    // NPW: raises access violation
        cerr << "Continued past invalid assignment (but shouldn't)\n";
    }
    // First time only, continue it (EXC:)
    __except(first? (first=0, EXCEPTION_CONTINUE_EXECUTION): EXCEPTION_EXECUTE_HANDLER){
        cerr << "Not first time (first = "<<first<<"), so quietly handle it\n";
    }

    cerr << "About to exit main()\n";
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::EXH  Handled Exception
void CMyBadActXATL::EXH(void) const
{
    char *ptr = NULL;
    __try {
        *ptr = 'h';     // NPW, raises exception (access violation)
        cerr << "Got to line after the invalid assignment\n";
    }
    __except(EXCEPTION_EXECUTE_HANDLER) {   // EXH: handling the exception
        cerr << "Handler is being run\n";
    }
    cerr << "About to exit main()\n";
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::EXH  Ignored Exception
void CMyBadActXATL::EXI(void) const
{
    char *ptr = NULL;
     __try {
	   __try {
			if (IDCANCEL==WarnUser()) 
				return;
			*ptr = 'h';     // NPW, raises exception (access violation)
			cerr << "Got to line after the invalid assignment\n";
		}
		__except(EXCEPTION_CONTINUE_SEARCH) {   // EXI: ignoring the exception
			cerr << "Handler is being run\n";
		}
	 }
     __except(EXCEPTION_EXECUTE_HANDLER) {   // EXH: handling the exception
        cerr << "Handler is being run\n";
	 }
   cerr << "About to exit main()\n";
}
////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::EXU  Unhandled Exception
static void ExuCB(void *arglist)
{
	throw "this is unhandled";  //EXU: nothing catches this
}
void CMyBadActXATL::EXU(void) const
{
	if (IDCANCEL==WarnUser()) 
		return;
	(void)_beginthread( ExuCB, 0, NULL);

}
////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::FFM  Freeing Freed Memory
void CMyBadActXATL::FFM(void) const
{
	 __try 
	{
		if (IDCANCEL==WarnUser()) 
			return;
		int *ptr1 = new int;    // Allocate an int
		int *ptr2 = ptr1;       // Bug: meant to duplicate the object, not
								// copy the pointer to the object.
		*ptr1 = 10;
		*ptr2 = 20;             // Overrides assignment of 10
		cerr << "ptr1" << " is " << *ptr1 << '\n';
		cerr << "ptr2" << " is " << *ptr2 << '\n';
		delete ptr1;
		delete ptr2;            // FFM: already freed by the line above
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::FIM  Freeing Invalid Memory
void CMyBadActXATL::FIM(void) const
{
	__try
	{
		if (IDCANCEL==WarnUser()) 
			return;
		int i;
		delete[] &i;    // FIM: freeing an address not allocated by new
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::FMM  Freeing Mismatched Memory
void CMyBadActXATL::FMM(void) const
{
	__try
	{
		if (IDCANCEL==WarnUser()) 
			return;
		HANDLE heap1, heap2;
		heap1 = HeapCreate(0, 1000, 0);
		heap2 = HeapCreate(0, 1000, 0);
		int *pointer = (int *) HeapAlloc(heap1, 0, sizeof(int));
		HeapFree(heap2, 0, pointer);   // Bug: meant heap1; FMM: freeing from wrong heap
		HeapDestroy(heap1);
		HeapDestroy(heap2);
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::FMR  Free Memory Read
void CMyBadActXATL::FMR(void) const
{
    int *ptr = new int[2];
    ptr[0] = 0;
    ptr[1] = 1;
    delete[] ptr;   // Bug: this was accidentally placed here instead of
                    // after the for() loop below.
    for (int i=0; i < 2; i++) {
        // FMR: these access memory which was already deallocated
        cerr << "element #" << i << " is " << ptr[i] << '\n';
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::FMW  Free Memory Write
void CMyBadActXATL::FMW(void) const
{
	if (IDCANCEL==WarnUser()) 
		return;
    int *ptr = new int[2];
    ptr[0] = 0;
    ptr[1] = 1;
    delete[] ptr;   // Bug: this was accidentally placed here instead of
                    // after the for() loop below.
    for (int i=0; i < 2; i++) {
        // FMR + FMW: these update memory which was already deallocated
        ptr[i] *= i;  
        cerr << "element #" << i << " is " << ptr[i] << '\n';  //FMR
    }
}


////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::FMWL  Late Detect Free Memory Write
void CMyBadActXATL::FMWL(void) const
{
	InformUser(IDS_FMWL_MSG);
	if (IDCANCEL==WarnUser()) 
		return;
    int *ptr = new int[2];
    ptr[0] = 0;
    ptr[1] = 1;
    delete[] ptr;   // Bug: this was accidentally placed here instead of
                    // after the for() loop below.
    for (int i=0; i < 2; i++) {
        ptr[i] *= i;  
        cerr << "element #" << i << " is " << ptr[i] << '\n';  
    }
    //FMWL: due to write to ptr after it was deleted
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::IVH  Invalid Handle
void CMyBadActXATL::IVH(void) const
{
    (void) LocalUnlock((HLOCAL)3);      // HAN: 3 is not a valid handle
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::HNDS_INUSE  Handle In Use
static long
get_alignment(void)
{
    SYSTEM_INFO sys_info;
    GetSystemInfo(&sys_info);
    return(sys_info.dwAllocationGranularity);
}
void CMyBadActXATL::HNDS_INUSE(void) const
{
    const long  align = get_alignment();
	InformUser(IDS_HNDS_INUSE_MSG);
    HANDLE      file_handle = CreateFile("file.txt",
                                GENERIC_READ|GENERIC_WRITE, 0, NULL,
                                CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (file_handle == INVALID_HANDLE_VALUE) {

        cerr << "Unable to create mappable file\n";
        return;
    }
    HANDLE      map_handle = CreateFileMapping(file_handle, NULL,
                                PAGE_READWRITE, 0, align, "mymap");
    if (map_handle == INVALID_HANDLE_VALUE) {
        cerr << "Unable to create actual mapping\n";
        return;
    }
    char       *pointer = (char *) MapViewOfFile(map_handle, FILE_MAP_WRITE,
                                        0, 0, align);

    if (pointer == NULL) {
        cerr << "Unable to map into address space\n";
        return;
    }
    strcpy(pointer, "hello\n");
    // "Should" clean things up here, but since we didn't, 
    //    HNDS_INUSE: map_handle still accessible and valid
    //    HNDS_INUSE: file_handle still accessible and valid
}
////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::ILK  COM Interface Leak
void CMyBadActXATL::ILK(void) const
{
	InformUser(IDS_HNDS_INUSE_MSG);
	LPMALLOC        lpIm;
	HRESULT hResult = CoGetMalloc( MEMCTX_TASK, (LPMALLOC*)&lpIm);

	if (S_OK==hResult) 
	{
		///IMalloc_Release(lpIm);  //not calling this causes an interface leak
	}
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::IPR  Invalid Pointer Read
void CMyBadActXATL::IPR(void) const
{
	__try
	{
		if (IDCANCEL==WarnUser()) 
			return;
		int *ptr = (int *) 0x80000000;  // Bug: pointer to reserved portion of address space
		for (int i=0; i < 2; i++) {
			// IPR: attempting to access invalid pointer
			cerr << "ptr[" << i << "] == " << ptr[i] << '\n';
		}
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::IPW  Invalid Pointer Write
void CMyBadActXATL::IPW(void) const
{
	__try
	{
		if (IDCANCEL==WarnUser()) 
			return;
		int *ptr = (int *) 0x80000000;  // Bug: pointer to reserved portion of address space
		for (int i=0; i < 2; i++) {
			// IPW + IPR: attempting to access invalid pointer
			ptr[i] = i;
			cerr << "ptr[" << i << "] == " << ptr[i] << '\n';
		}
	}
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::MAF  Memory Allocation Failure
#define VERY_LARGE 3000000000       // More RAM than we can get
void CMyBadActXATL::MAF(void) const
{
    int *ptr = (int *)malloc(VERY_LARGE / sizeof(int));   // MAF: can't get this much
    if (ptr == 0) {
        cerr << "Failed to alloc, as expected\n";
		return;
    } else {
        cerr << "Got " << VERY_LARGE << " bytes @" << (unsigned long)ptr << '\n';
		free(ptr);
		return;
	}
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::MIU  Memory In Use
void CMyBadActXATL::MIU(void) const
{
	InformUser(IDS_MIU_MSG);
    // Don't free the memory, but retain a pointer to it:
    // should show up as a distinctive 500K block on the MIU report.
    static char *ptr = new char[500000];
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::MLK  Memory Leak
void CMyBadActXATL::MLK(void) const
{
    // Will show up as leaks totaling 5K on the MLK report.
	InformUser(IDS_MLK_MSG);
    // Allocate and discard 5K 
    (void) new char[1000];
    (void) new char[1000];
    (void) new char[1000];
    (void) new char[1000];
    (void) new char[1000];
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::MPK  Potential Memory Leak
void CMyBadActXATL::MPK(void) const
{
    // MPK Will show up as potentially leaked.
	InformUser(IDS_MPK_MSG);
    static char *ptr = new char[500000];
    // Don't free the memory; retain only a pointer to the middle of it.
    ptr += 100;
}


////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::NPR  Null Pointer Read
void CMyBadActXATL::NPR(void) const
{
	__try
	{
		if (IDCANCEL==WarnUser()) 
			return;
		int *ptr = (int *) 0x0; // Bug: null pointer
		for (int i=0; i < 2; i++) {
			// NPR: attempting to access null pointer
			cerr << "ptr[" << i << "] == " << ptr[i] << '\n';
		}
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::NPW  Null Pointer Write
void CMyBadActXATL::NPW(void) const
{
	__try
	{
		if (IDCANCEL==WarnUser()) 
			return;
		int *ptr = (int *) 0x0; // Bug: null pointer
		for (int i=0; i < 2; i++) {
			// NPW: attempting to access null pointer
			ptr[i] = i;
			cerr << "ptr[" << i << "] == " << ptr[i] << '\n';
		}
    }
    __except(EXCEPTION_EXECUTE_HANDLER) 
	{
		 // EXH: handling the exception
    }
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::ODS  OutputDebugString
void CMyBadActXATL::ODS(void) const
{
	OutputDebugString(TEXT("Purify early and often for best results"));
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::PAR  Bad Parameter
void CMyBadActXATL::PAR(void) const
{
	char string[40] = "Purify early and often for best results";
	char *dest;
	char *src;

	dest= string+10;
	src = string+4;
	memcpy( dest, src, 20 );	   //PAR: src and dest overlap
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::UMC  Uninitialized Memory Copy
void CMyBadActXATL::UMC(void) const
{
    char *ptr = new char[10];
    char var[10];

	InformUser(IDS_UMC_MSG);
	memcpy(var, ptr, 10);	//UMC warning

	delete[] ptr;
}

////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL::UMR  Uninitialized Memory Read
void CMyBadActXATL::UMR(void) const
{
	InformUser(IDS_UMR_MSG);
    int *ptr = new int;
    cerr << "*ptr is " << *ptr << '\n';     // UMR: no value was set in ptr
    delete[] ptr;
}

