////////////////////////////////////////////////////////////////////////////////
// BadActX ActiveX Demonstration Program For Purify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
// Venki Muthanna and John Birchfield
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// BadActXATL.h : Declaration of the CMyBadActXATL

#ifndef __BADACTXATL_H_
#define __BADACTXATL_H_

#include "resource.h"       // main symbols

#include "BadActXGridCtrl.h"	// for class CMyBadActXGridCtrl	

#define MAX_PATH_LEN _MAX_PATH + 1

#define abr 1	
#define abw 2	
#define abwl 3	
#define	bsr 4
#define	bsw 5
#define	exc 6
#define	exh 7
#define	exi 8
#define	exu 9
#define	ffm 10
#define	fim 11
#define	fmm 12
#define	fmr 13
#define	fmw 14
#define	fmwl 15
#define	ivh 16	
#define	hwnds_inuse 17
#define	ilk 18
#define	ipr 19
#define	ipw 20
#define	maf 21
#define	miu 22
#define	mlk 23
#define	mpk 24
#define	npr 25
#define	npw 26
#define	ods 27
#define	par 28
#define	umc 29
#define	umr 30

/////////////////////////////////////////////////////////////////////////////
// CMyBadActXATL
class ATL_NO_VTABLE CMyBadActXATL : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMyBadActXATL, &CLSID_BadActXATL>,
	public CComControl<CMyBadActXATL>,
	public CStockPropImpl<CMyBadActXATL, IMyBadActXATL, &IID_IMyBadActXATL, &LIBID_BADACTXLib>,
	public IProvideClassInfo2Impl<&CLSID_BadActXATL, NULL, &LIBID_BADACTXLib>,
	public IPersistStreamInitImpl<CMyBadActXATL>,
	public IPersistStorageImpl<CMyBadActXATL>,
	public IQuickActivateImpl<CMyBadActXATL>,
	public IOleControlImpl<CMyBadActXATL>,
	public IOleObjectImpl<CMyBadActXATL>,
	public IOleInPlaceActiveObjectImpl<CMyBadActXATL>,
	public IViewObjectExImpl<CMyBadActXATL>,
	public IOleInPlaceObjectWindowlessImpl<CMyBadActXATL>,
	public IDataObjectImpl<CMyBadActXATL>,
	public ISpecifyPropertyPagesImpl<CMyBadActXATL>,
	public IObjectSafety
{
public:
	CMyBadActXATL();
	~CMyBadActXATL();

DECLARE_REGISTRY_RESOURCEID(IDR_BADACTXATL)

BEGIN_COM_MAP(CMyBadActXATL)
	COM_INTERFACE_ENTRY(IMyBadActXATL)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

BEGIN_PROPERTY_MAP(CMyBadActXATL)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()

	// hand written stuff
	LRESULT OnSelChangeMsFlexGrid(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDblClickMsFlexGrid(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnClickMsFlexGrid(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

BEGIN_MSG_MAP(CMyBadActXATL)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
	MESSAGE_HANDLER(IDC_IMPORTED_SEL_CHANGE		/* SelChange */, OnSelChangeMsFlexGrid)
	MESSAGE_HANDLER(IDC_IMPORTED_SINGLE_CLICK	/* Click */,     OnClickMsFlexGrid)
	MESSAGE_HANDLER(IDC_IMPORTED_DBL_CLICK		/* DblClick */,	 OnDblClickMsFlexGrid)
END_MSG_MAP()


// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
		ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}


// IMyBadActXATL
public:
	HRESULT OnDraw(ATL_DRAWINFO& di);

// customizations
public:
	virtual HWND	CreateControlWindow(HWND hWndParent, RECT& rcPos);
	STDMETHOD		(InPlaceActivate)(LONG iVerb, const RECT* prcPosRect = NULL);
	STDMETHOD		(InPlaceDeactivate)(void);
   // IObjectSafety implementation
	STDMETHOD		(GetInterfaceSafetyOptions)(REFIID riid, DWORD *pdwSupportedOptions, DWORD *pdwEnabledOptions);
	STDMETHOD		(SetInterfaceSafetyOptions)(REFIID riid, DWORD dwOptionSetMask, DWORD dwEnabledOptions);
	///CMyBadActXCtrl	m_BadActXCtrl;
protected:
	CWnd			m_PvtWnd;
	CMyGridCtrl*	m_MSFlexGrid;		
	int				m_CurSelRow;
	HWND			m_hWndParent;


	void			AddToBadThingsList(const UINT row, 
									   const COLORREF color,
									   const UINT resourceId);
	const int		WarnUser() const;
	void			InformUser(const UINT msgId) const;

	// assorted bad things that Purify Can Detect
	void	ABR(void)  const;		// Array Bounds Read Error
	void	ABW(void)  const;		// Array Bounds Write Error
	void	ABWL(void) const;		// Late Detect Array Bounds Write Error
	void	BSR(void)  const;		// Beyond Stack Read Error
	void	BSW(void)  const;		// Beyond Stack Write Error
	void	EXC(void)  const;		// Continued Exception
	void	EXH(void)  const;		// Handled Exception
	void	EXI(void)  const;		// Ignored Exception
	void	EXU(void)  const;		// Unhandled Exception
	void	FFM(void)  const;		// Freeing Freed Memory
	void	FIM(void)  const;		// Freeing Invalid Memory
	void	FMM(void)  const;		// Freeing Mismatched Memory
	void	FMR(void)  const;		// Free Memory Read
	void	FMW(void)  const;		// Free Memory Write
	void	FMWL(void) const;		// Late Detect Free Memory Write
	void	IVH(void)  const;		// Invalid Handle
	void	HNDS_INUSE(void)  const;// Handle In Use
	void	ILK(void)  const;		// COM interface leak
	void	IPR(void)  const;		// Invalid Pointer Read
	void	IPW(void)  const;		// Invalid Pointer Write
	void	MAF(void)  const;		// Memory Allocation Failure
	void	MIU(void)  const;		// Memory In Use
	void	MLK(void)  const;		// Memory Leak
	void	MPK(void)  const;		// Potential Memory Leak
	void	NPR(void)  const;		// Null Pointer Read
	void	NPW(void)  const;		// Null Pointer Write
	void	ODS(void)  const;		// OutputDebugString
	void	PAR(void)  const;		// Bad parameter
	void	UMC(void)  const;		// Uninitialized Memory Copy
	void	UMR(void)  const;		// Uninitialized Memory Read
};

#endif //__BADACTXATL_H_
