////////////////////////////////////////////////////////////////////////////////
// BadActX ActiveX Demonstration Program For Purify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
// Venki Muthanna and John Birchfield
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// BadActXGridCtrl.h: interface for the CMyGridCtrl class.
//
//////////////////////////////////////////////////////////////////////
//********************************************************************
// NOTE: This Derived class exists as a result of our experience
// in first implementing the COM control in MFC.
// First we had a MFC dialog window.
// We then added the Microsoft Flex Grid control through the command
// "Insert Active X Control". 
// Then we invoked the Class Wizzard ahd created a member variable for
// this control. Magically the following files were automatically created: 
//		msflexgrid.*
//		font.*
//		picture.*
//		rowcursor.*
// Next we added the events we are interested in that Microsoft Flex 
// Grid control exposed:
//		SelChange
//		Click
//		Double Click.
// At this point, the Class Wizzard added all of the DECLARE_EVENTSINK_MAP
// stuff.
// Well, unfortunately the ATL 2.0 CWindowImpl implementation does not
// yet support this interface. Subsequently, we wrapped the CMSFlexGrid
// class in MFC, trapped the events we were interested in and dispatched
// them to the ATL parent ctrl!
//********************************************************************
#if !defined(AFX_BADACTXGRIDCTRL_H__827DBBC0_FE19_11D0_A51B_006097408C22__INCLUDED_)
#define AFX_BADACTXGRIDCTRL_H__827DBBC0_FE19_11D0_A51B_006097408C22__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//{{AFX_INCLUDES()
#include "msflexgrid.h"
//}}AFX_INCLUDES

#define IDC_IMPORTED_SEL_CHANGE		69
#define IDC_IMPORTED_SINGLE_CLICK	600
#define IDC_IMPORTED_DBL_CLICK		601

class CMyGridCtrl : public CMSFlexGrid  
{
public:
	CMyGridCtrl();
	virtual ~CMyGridCtrl();

	///BEGIN_MSG_MAP(CMyGridCtrl)
	///END_MSG_MAP()

protected:

	//{{AFX_MSG(CMyBadActXCtrl)
	afx_msg void OnSelChangeMsFlexGrid();
	afx_msg void OnDblClickMsFlexGrid();
	afx_msg void OnClickMsFlexGrid();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	///DECLARE_MESSAGE_MAP()

};

#endif // !defined(AFX_BADACTXGRIDCTRL_H__827DBBC0_FE19_11D0_A51B_006097408C22__INCLUDED_)
