//*
//* buydlg.cpp
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// buydlg.cpp : implementation file
//

#include "stdafx.h"
#include "Stock.h"
#include "buydlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBuyDlg dialog


CBuyDlg::CBuyDlg(CWnd* pParent)
	: CDialog(CBuyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBuyDlg)
	m_NumShares = 0;
	m_Symbol = _T("");
	//}}AFX_DATA_INIT
}

//CBuyDlg::OnInitDialog - fills the list box with the available
// stock symbols.
BOOL CBuyDlg::OnInitDialog ()
{
char* cp;
CListBox* pLB;
	if (CDialog::OnInitDialog ())
		{
		pLB = (CListBox*) GetDlgItem (IDC_SYMBOL_LIST);
		pLB->SetColumnWidth(pLB->GetItemHeight(0) *5);
		for (StockSymbols.Restart (); cp = StockSymbols.GetNextAll (); 
			pLB->AddString (cp) );
		//pLB->SetCurSel (0);
		return TRUE;
		}
	return FALSE;
}

void CBuyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBuyDlg)
	DDX_Text(pDX, IDC_NUM_SHARES, m_NumShares);
	DDV_MinMaxInt(pDX, m_NumShares, 1, 100000);
	DDX_LBString(pDX, IDC_SYMBOL_LIST, m_Symbol);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBuyDlg, CDialog)
	//{{AFX_MSG_MAP(CBuyDlg)
	ON_LBN_DBLCLK(IDC_SYMBOL_LIST, OnDblclkSymbolList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBuyDlg message handlers

//CBuyDlg::OnDblclkSymbolList - causes dialog to close and return IDOK
// when the user double clicks in the symbol list box.
void CBuyDlg::OnDblclkSymbolList() 
{
	if (UpdateData (TRUE)) EndDialog (IDOK);	
}
