//*
//* shortdlg.cpp
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// shortdlg.cpp : implementation file
//

#include "stdafx.h"
#include "Stock.h"
#include "shortdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShortDlg dialog


CShortDlg::CShortDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShortDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShortDlg)
	m_NumShares = 0;
	m_Symbol = _T("");
	//}}AFX_DATA_INIT
}


//CShortDlg::OnInitDialog - fills the list box with the available
// stock symbols.
BOOL CShortDlg::OnInitDialog ()
{
char* cp;
CListBox* pLB;
	if (CDialog::OnInitDialog ())
		{
		pLB = (CListBox*) GetDlgItem (IDC_SYMBOL_LIST);
		pLB->SetColumnWidth(pLB->GetItemHeight(0) *5);
		for (StockSymbols.Restart (); cp = StockSymbols.GetNextAll (); 
			pLB->AddString (cp) );
		pLB->SetCurSel (0);
		return TRUE;
		}
	return FALSE;
}

void CShortDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShortDlg)
	DDX_Text(pDX, IDC_NUM_SHARES, m_NumShares);
	DDX_LBString(pDX, IDC_SYMBOL_LIST, m_Symbol);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CShortDlg, CDialog)
	//{{AFX_MSG_MAP(CShortDlg)
	ON_LBN_DBLCLK(IDC_SYMBOL_LIST, OnDblclkSymbolList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CShortDlg message handlers

//CShortDlg::OnDblclkSymbolList - causes dialog to close and return IDOK
// when the user double clicks in the symbol list box.
void CShortDlg::OnDblclkSymbolList() 
{
	if (UpdateData (TRUE)) EndDialog (IDOK);	
}
