//*
//* stockvw.cpp
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// Stockvw.cpp : implementation of the CStockView class
//

#include "stdafx.h"
#include "Stock.h"

#include "Stockdoc.h"
#include "Stockvw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStockView

IMPLEMENT_DYNCREATE(CStockView, CView)

BEGIN_MESSAGE_MAP(CStockView, CView)
	//{{AFX_MSG_MAP(CStockView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStockView construction/destruction

CStockView::CStockView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CStockView drawing

void CStockView::OnDraw(CDC* pDC)
{
	CBrush brush;
	CRect r;
	CSize s;
	int x, i;
	CStockDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	GetClientRect (&r); r.right++; r.bottom++;
	pDC->SetBkMode (TRANSPARENT);
	if (!brush.CreateSolidBrush (RGB(0, 0, 0))) return;
	pDC->FillRect (&r, &brush);

	CStockDoc* doc = (CStockDoc*) GetDocument ();


	pDC->SetTextColor (RGB (0xff, 0xff, 0xff));
	pDC->SetTextAlign (TA_TOP | TA_LEFT);
	x = 2;
	s = pDC->GetTextExtent ("Agy", 3);
	for (i = 0; i < doc->m_Portfolio.GetSize (); i++)
	{
		pDC->TextOut (2, x, doc->m_Portfolio [i].m_strDisplay);
		x += s.cx;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CStockView diagnostics

#ifdef _DEBUG
void CStockView::AssertValid() const
{
	CView::AssertValid();
}

void CStockView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CStockDoc* CStockView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStockDoc)));
	return (CStockDoc*)m_pDocument;
}
#endif //_DEBUG
