//*
//* symview.cpp
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// symview.cpp : implementation file
//

#include "stdafx.h"
#include "Stock.h"
#include "symdoc.h"
#include "symview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSymView

IMPLEMENT_DYNCREATE(CSymView, CView)

CSymView::CSymView()
{
}

BEGIN_MESSAGE_MAP(CSymView, CView)
	//{{AFX_MSG_MAP(CSymView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//CSymView::OnDraw - draws the volume traded bar and the price line 
// for a simple trade history chart.
// Input: pDC	-pointer to the display context
void CSymView::OnDraw(CDC* pDC)
{
	CBrush brush, volbrush;
	CPen pen;
	CPoint pinc, pnt;
	int i, x;
	CRect r, rv;
	CSymDoc* doc = (CSymDoc*) GetDocument ();

	GetClientRect (&r);
	r.InflateRect (1, 1);

	pDC->SetBkMode (TRANSPARENT);
	if (! pen.CreatePen (PS_SOLID, 2, RGB (0, 0xff, 0))) return;
	CPen* oldpen = pDC->SelectObject (&pen);

	pinc.x = r.right >> 5;
	pinc.y = r.bottom >> 5;

	//display the volume bars
	i = (doc->m_Last + 1) & MAXTRANSACTIONS;
	rv.SetRect (0, r.bottom, pinc.x, r.bottom);
	if (!volbrush.CreateSolidBrush (RGB(0xff, 0, 0))) return;
	do
	{
		rv.top = r.bottom - pinc.y * doc->m_Volumes [i];
	 	pDC->FillRect (&rv, &volbrush);
		rv.OffsetRect (pinc.x, 0);
		i = (i + 1) & MAXTRANSACTIONS;
	} while (i != doc->m_Last);

	// draw price history line
	i = (doc->m_Last + 1) & MAXTRANSACTIONS;
	x = 0;
	pDC->MoveTo (x, r.bottom - pinc.y * (doc->m_Prices [i] - doc->m_PriceMin));
	while (i != doc->m_Last)
	{
		i = (i + 1) & MAXTRANSACTIONS;
		x += pinc.x;
		pDC->LineTo (x, r.bottom - pinc.y * (doc->m_Prices [i] - doc->m_PriceMin));
	} 
	pDC->LineTo (r.right, r.bottom - pinc.y * (doc->m_Prices [doc->m_Last] - doc->m_PriceMin));
	pDC->SelectObject (oldpen);
	//print the current stock price
	pDC->SetTextColor (RGB (0, 0, 0));
	pDC->SetTextAlign (TA_TOP | TA_RIGHT);
	pDC->TextOut (r.Width (), 
		r.bottom - pinc.y * (doc->m_Prices [doc->m_Last] - doc->m_PriceMin),
		doc->m_StrPrice);
}

/////////////////////////////////////////////////////////////////////////////
// CSymView diagnostics

#ifdef _DEBUG
void CSymView::AssertValid() const
{
	CView::AssertValid();
}

void CSymView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

