'===============================================================================
'
' FormVSLDemo.vb
'
' Implements the UI for PurifyPlus demo for Dot Net profiling.
' 
' This is a simple word counting application that has some 
' intentional performance bottlenecks, memory leaks and 
' 'untested buggy code'. Thus it can demo Purify, Quantify and Coverage 
' capabilities. You can use it with all PurifyPlus components and see if
' Purify actually helps to pinpoint problems hidden in this code.
' This application is intentionally split into two components (File Parser and UI).
' Each component is implemented in different language to demonstrate cross-language
' capabilities of PurifyPlus.
' This code also takes advantage of PureAPI - a managed interface that helps to 
' control PurifyPlus data collection from within the user code.
' 
'

Public Class FormVSLDemo
    Inherits System.Windows.Forms.Form


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ListViewWords As System.Windows.Forms.ListView
    Friend WithEvents ColumnWord As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnCount As System.Windows.Forms.ColumnHeader
    Friend WithEvents TextPath As System.Windows.Forms.TextBox
    Friend WithEvents ButtonSelPath As System.Windows.Forms.Button
    Friend WithEvents OpenFileDialog As System.Windows.Forms.OpenFileDialog
    Friend WithEvents ProgressCount As System.Windows.Forms.ProgressBar
    Friend WithEvents StatusBar As System.Windows.Forms.StatusBar
    Friend WithEvents PanelWords As System.Windows.Forms.StatusBarPanel
    Friend WithEvents PanelBytes As System.Windows.Forms.StatusBarPanel
    Friend WithEvents PanelTotal As System.Windows.Forms.StatusBarPanel
    Friend WithEvents Panel1 As System.Windows.Forms.StatusBarPanel
    Friend WithEvents Panel2 As System.Windows.Forms.StatusBarPanel
    Friend WithEvents Panel3 As System.Windows.Forms.StatusBarPanel
    Friend WithEvents CheckFixPerformance As System.Windows.Forms.CheckBox
    Friend WithEvents CheckFixLeaks As System.Windows.Forms.CheckBox
    Friend WithEvents CheckClickMe As System.Windows.Forms.CheckBox
    Friend WithEvents ButtonRun As System.Windows.Forms.Button
    Friend WithEvents CheckUsePureAPI As System.Windows.Forms.CheckBox
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
    Friend WithEvents TimerUI As System.Windows.Forms.Timer
    Friend WithEvents LabelMem As System.Windows.Forms.Label
    Friend WithEvents TextBoxMem As System.Windows.Forms.TextBox
    Friend WithEvents LabelTime As System.Windows.Forms.Label
    Friend WithEvents TextBoxTime As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.TextPath = New System.Windows.Forms.TextBox
        Me.ButtonSelPath = New System.Windows.Forms.Button
        Me.ListViewWords = New System.Windows.Forms.ListView
        Me.ColumnWord = New System.Windows.Forms.ColumnHeader
        Me.ColumnCount = New System.Windows.Forms.ColumnHeader
        Me.OpenFileDialog = New System.Windows.Forms.OpenFileDialog
        Me.StatusBar = New System.Windows.Forms.StatusBar
        Me.Panel1 = New System.Windows.Forms.StatusBarPanel
        Me.PanelWords = New System.Windows.Forms.StatusBarPanel
        Me.Panel2 = New System.Windows.Forms.StatusBarPanel
        Me.PanelBytes = New System.Windows.Forms.StatusBarPanel
        Me.Panel3 = New System.Windows.Forms.StatusBarPanel
        Me.PanelTotal = New System.Windows.Forms.StatusBarPanel
        Me.ProgressCount = New System.Windows.Forms.ProgressBar
        Me.CheckFixPerformance = New System.Windows.Forms.CheckBox
        Me.CheckFixLeaks = New System.Windows.Forms.CheckBox
        Me.CheckClickMe = New System.Windows.Forms.CheckBox
        Me.ButtonRun = New System.Windows.Forms.Button
        Me.CheckUsePureAPI = New System.Windows.Forms.CheckBox
        Me.GroupBox2 = New System.Windows.Forms.GroupBox
        Me.TextBoxMem = New System.Windows.Forms.TextBox
        Me.LabelMem = New System.Windows.Forms.Label
        Me.LabelTime = New System.Windows.Forms.Label
        Me.TextBoxTime = New System.Windows.Forms.TextBox
        Me.GroupBox3 = New System.Windows.Forms.GroupBox
        Me.TimerUI = New System.Windows.Forms.Timer(Me.components)
        CType(Me.Panel1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PanelWords, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.Panel2, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PanelBytes, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.Panel3, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PanelTotal, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.GroupBox2.SuspendLayout()
        Me.SuspendLayout()
        '
        'TextPath
        '
        Me.TextPath.Location = New System.Drawing.Point(24, 320)
        Me.TextPath.Name = "TextPath"
        Me.TextPath.Size = New System.Drawing.Size(240, 20)
        Me.TextPath.TabIndex = 0
        Me.TextPath.Text = ""
        '
        'ButtonSelPath
        '
        Me.ButtonSelPath.Font = New System.Drawing.Font("Wingdings", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(2, Byte))
        Me.ButtonSelPath.Location = New System.Drawing.Point(280, 320)
        Me.ButtonSelPath.Name = "ButtonSelPath"
        Me.ButtonSelPath.Size = New System.Drawing.Size(32, 24)
        Me.ButtonSelPath.TabIndex = 1
        Me.ButtonSelPath.Text = "<"
        '
        'ListViewWords
        '
        Me.ListViewWords.AllowDrop = True
        Me.ListViewWords.Anchor = CType((System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.ListViewWords.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnWord, Me.ColumnCount})
        Me.ListViewWords.FullRowSelect = True
        Me.ListViewWords.GridLines = True
        Me.ListViewWords.Location = New System.Drawing.Point(16, 48)
        Me.ListViewWords.MultiSelect = False
        Me.ListViewWords.Name = "ListViewWords"
        Me.ListViewWords.Size = New System.Drawing.Size(412, 264)
        Me.ListViewWords.Sorting = System.Windows.Forms.SortOrder.Ascending
        Me.ListViewWords.TabIndex = 2
        Me.ListViewWords.View = System.Windows.Forms.View.Details
        '
        'ColumnWord
        '
        Me.ColumnWord.Text = "Word"
        Me.ColumnWord.Width = 350
        '
        'ColumnCount
        '
        Me.ColumnCount.Text = "Count"
        '
        'OpenFileDialog
        '
        Me.OpenFileDialog.Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*"
        '
        'StatusBar
        '
        Me.StatusBar.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.StatusBar.Dock = System.Windows.Forms.DockStyle.None
        Me.StatusBar.Location = New System.Drawing.Point(0, 429)
        Me.StatusBar.Name = "StatusBar"
        Me.StatusBar.Panels.AddRange(New System.Windows.Forms.StatusBarPanel() {Me.Panel1, Me.PanelWords, Me.Panel2, Me.PanelBytes, Me.Panel3, Me.PanelTotal})
        Me.StatusBar.ShowPanels = True
        Me.StatusBar.Size = New System.Drawing.Size(450, 16)
        Me.StatusBar.SizingGrip = False
        Me.StatusBar.TabIndex = 3
        Me.StatusBar.Text = "Word Counter"
        '
        'Panel1
        '
        Me.Panel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
        Me.Panel1.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None
        Me.Panel1.Text = "Words"
        Me.Panel1.Width = 47
        '
        'PanelWords
        '
        Me.PanelWords.Alignment = System.Windows.Forms.HorizontalAlignment.Right
        Me.PanelWords.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
        Me.PanelWords.Text = "0"
        Me.PanelWords.Width = 20
        '
        'Panel2
        '
        Me.Panel2.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
        Me.Panel2.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None
        Me.Panel2.Text = "Bytes"
        Me.Panel2.Width = 43
        '
        'PanelBytes
        '
        Me.PanelBytes.Alignment = System.Windows.Forms.HorizontalAlignment.Right
        Me.PanelBytes.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
        Me.PanelBytes.Text = "0"
        Me.PanelBytes.Width = 20
        '
        'Panel3
        '
        Me.Panel3.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
        Me.Panel3.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None
        Me.Panel3.Text = "Total"
        Me.Panel3.Width = 39
        '
        'PanelTotal
        '
        Me.PanelTotal.Alignment = System.Windows.Forms.HorizontalAlignment.Right
        Me.PanelTotal.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
        Me.PanelTotal.Text = "0"
        Me.PanelTotal.Width = 20
        '
        'ProgressCount
        '
        Me.ProgressCount.Location = New System.Drawing.Point(304, 432)
        Me.ProgressCount.Name = "ProgressCount"
        Me.ProgressCount.Size = New System.Drawing.Size(136, 8)
        Me.ProgressCount.TabIndex = 4
        '
        'CheckFixPerformance
        '
        Me.CheckFixPerformance.Location = New System.Drawing.Point(24, 376)
        Me.CheckFixPerformance.Name = "CheckFixPerformance"
        Me.CheckFixPerformance.Size = New System.Drawing.Size(112, 16)
        Me.CheckFixPerformance.TabIndex = 6
        Me.CheckFixPerformance.Text = "Fix Performance"
        '
        'CheckFixLeaks
        '
        Me.CheckFixLeaks.Location = New System.Drawing.Point(160, 376)
        Me.CheckFixLeaks.Name = "CheckFixLeaks"
        Me.CheckFixLeaks.Size = New System.Drawing.Size(112, 16)
        Me.CheckFixLeaks.TabIndex = 7
        Me.CheckFixLeaks.Text = "Fix Leaks"
        '
        'CheckClickMe
        '
        Me.CheckClickMe.Location = New System.Drawing.Point(368, 8)
        Me.CheckClickMe.Name = "CheckClickMe"
        Me.CheckClickMe.Size = New System.Drawing.Size(72, 24)
        Me.CheckClickMe.TabIndex = 8
        Me.CheckClickMe.Text = "Click Me"
        '
        'ButtonRun
        '
        Me.ButtonRun.Location = New System.Drawing.Point(344, 320)
        Me.ButtonRun.Name = "ButtonRun"
        Me.ButtonRun.Size = New System.Drawing.Size(88, 24)
        Me.ButtonRun.TabIndex = 9
        Me.ButtonRun.Text = "Run"
        '
        'CheckUsePureAPI
        '
        Me.CheckUsePureAPI.Location = New System.Drawing.Point(296, 376)
        Me.CheckUsePureAPI.Name = "CheckUsePureAPI"
        Me.CheckUsePureAPI.Size = New System.Drawing.Size(112, 16)
        Me.CheckUsePureAPI.TabIndex = 10
        Me.CheckUsePureAPI.Text = "Use PureAPI"
        '
        'GroupBox2
        '
        Me.GroupBox2.Controls.Add(Me.TextBoxMem)
        Me.GroupBox2.Controls.Add(Me.LabelMem)
        Me.GroupBox2.Controls.Add(Me.LabelTime)
        Me.GroupBox2.Controls.Add(Me.TextBoxTime)
        Me.GroupBox2.Location = New System.Drawing.Point(8, 360)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(440, 64)
        Me.GroupBox2.TabIndex = 11
        Me.GroupBox2.TabStop = False
        Me.GroupBox2.Text = "QA Console"
        '
        'TextBoxMem
        '
        Me.TextBoxMem.Location = New System.Drawing.Point(96, 40)
        Me.TextBoxMem.Name = "TextBoxMem"
        Me.TextBoxMem.ReadOnly = True
        Me.TextBoxMem.Size = New System.Drawing.Size(96, 20)
        Me.TextBoxMem.TabIndex = 1
        Me.TextBoxMem.Text = ""
        '
        'LabelMem
        '
        Me.LabelMem.Location = New System.Drawing.Point(16, 40)
        Me.LabelMem.Name = "LabelMem"
        Me.LabelMem.Size = New System.Drawing.Size(80, 16)
        Me.LabelMem.TabIndex = 0
        Me.LabelMem.Text = "Memory Used"
        '
        'LabelTime
        '
        Me.LabelTime.Location = New System.Drawing.Point(248, 40)
        Me.LabelTime.Name = "LabelTime"
        Me.LabelTime.Size = New System.Drawing.Size(80, 16)
        Me.LabelTime.TabIndex = 0
        Me.LabelTime.Text = "Elapsed Time"
        '
        'TextBoxTime
        '
        Me.TextBoxTime.Location = New System.Drawing.Point(328, 40)
        Me.TextBoxTime.Name = "TextBoxTime"
        Me.TextBoxTime.ReadOnly = True
        Me.TextBoxTime.Size = New System.Drawing.Size(96, 20)
        Me.TextBoxTime.TabIndex = 1
        Me.TextBoxTime.Text = ""
        '
        'GroupBox3
        '
        Me.GroupBox3.Location = New System.Drawing.Point(8, 0)
        Me.GroupBox3.Name = "GroupBox3"
        Me.GroupBox3.Size = New System.Drawing.Size(440, 352)
        Me.GroupBox3.TabIndex = 12
        Me.GroupBox3.TabStop = False
        '
        'TimerUI
        '
        '
        'FormVSLDemo
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(450, 451)
        Me.Controls.Add(Me.CheckUsePureAPI)
        Me.Controls.Add(Me.ButtonRun)
        Me.Controls.Add(Me.CheckClickMe)
        Me.Controls.Add(Me.CheckFixLeaks)
        Me.Controls.Add(Me.CheckFixPerformance)
        Me.Controls.Add(Me.ProgressCount)
        Me.Controls.Add(Me.StatusBar)
        Me.Controls.Add(Me.ListViewWords)
        Me.Controls.Add(Me.ButtonSelPath)
        Me.Controls.Add(Me.TextPath)
        Me.Controls.Add(Me.GroupBox2)
        Me.Controls.Add(Me.GroupBox3)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.MaximizeBox = False
        Me.Name = "FormVSLDemo"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "Word Count"
        CType(Me.Panel1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PanelWords, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.Panel2, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PanelBytes, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.Panel3, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PanelTotal, System.ComponentModel.ISupportInitialize).EndInit()
        Me.GroupBox2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region
    Dim wc As WordCount.WordCount               ' The Word Counter
    Dim fs As System.IO.FileStream              ' Input file stream
    Dim bFixPerformance, bFixLeaks As Boolean   ' True if the 'Good Performance' sample is to be invoked
    Dim FileSize As Long                        ' Input file size
    Dim timeStart, timeElapsed As TimeSpan      ' Start time and elapsed time for the operation
    Dim ParsingThread As Threading.Thread       ' A separate thread for parsing and counting


    Private Shared bSortAscending As Boolean = True
    '
    ' Two different list sorters below:
    '---------------------------------------------------------------------------
    ' <summary>
    ' Sorts the results list box alphabetically
    ' </summary>
    Private Class WordSorter
        Implements IComparer

        Public Overloads Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
            Dim nRet As Integer = 0
            Dim i1 As ListViewItem = x
            Dim i2 As ListViewItem = y
            nRet = String.Compare(i1.Text, i2.Text)
            If (Not bSortAscending) Then
                nRet = -nRet
            End If
            Return nRet
        End Function

    End Class

    '---------------------------------------------------------------------------
    ' <summary>
    ' Sorts the results list box by frequency
    ' </summary>
    Private Class FreqSorter
        Implements IComparer

        Public Overloads Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
            Dim i1 As ListViewItem
            Dim i2 As ListViewItem
            Dim n1, n2, nRet As Integer
            i1 = x
            i2 = y
            nRet = 0
            n1 = Convert.ToInt32(i1.SubItems(1).Text)
            n2 = Convert.ToInt32(i2.SubItems(1).Text)
            If n1 > n2 Then
                nRet = 1
            ElseIf n1 < n2 Then
                nRet = -1
            End If
            If (Not bSortAscending) Then
                nRet = -nRet
            End If
            Return nRet
        End Function
    End Class

    Private wsort As WordSorter = New WordSorter()
    Private fsort As FreqSorter = New FreqSorter()

    Private Sub SetRunButtonState(ByVal Enable As Boolean)
        ButtonRun.Enabled = Enable
    End Sub

    '---------------------------------------------------------------------------
    ' <summary>
    ' Show the parsing results
    ' The results list box and all the appropriate form fields are updated here.
    ' Note that this method is being invoked from the parsing thread.
    ' Hence the invocation is being queued to the main form thread by using the 
    ' Form.Invoke() method
    ' </summary>
    Private Sub ShowResults()
        Dim ind As IDictionaryEnumerator                ' Cache enumerator
        Dim nItems As Integer                           ' Number of items
        Dim nRows As Integer                            ' Number of rows to display
        Try
            ProgressCount.Value = 100                       ' Fix the progress bar
            ListViewWords.Items.Clear()                 ' Remove previous results
            PanelBytes.Text = wc.GetnBytes().ToString() ' Display bytes
            PanelWords.Text = wc.GetnWords().ToString() ' Display words
            ind = wc.m_Words.GetEnumerator()
            nRows = System.Convert.ToInt32(wc.m_Words.Count)
            'Array of items to display
            Dim NewItems As ListViewItem() = Array.CreateInstance(GetType(ListViewItem), nRows)
            While ind.MoveNext And nItems < nRows
                ' Populate the array of items
                Dim itemNext As ListViewItem
                itemNext = New ListViewItem(ind.Key.ToString())
                itemNext.SubItems.Add(ind.Value.ToString())
                NewItems(nItems) = itemNext
                nItems = nItems + 1
            End While
            ' Display the list
            If (NewItems.Length > 0) Then
                ListViewWords.Items.AddRange(NewItems)
            End If
            ' Display diagnostic info
            timeElapsed = New TimeSpan(DateTime.Now.Ticks).Subtract(timeStart)
            TextBoxTime.Text = timeElapsed.Minutes.ToString() _
                             + ":" + timeElapsed.Seconds.ToString() _
                             + "." + timeElapsed.Milliseconds.ToString()
            GC.Collect()
            TextBoxMem.Text = GC.GetTotalMemory(False).ToString()

        Catch ex As Exception
            MsgBox("OOPS... Exeption processed: " + ex.ToString())
            ' OOPS
            ' ...
        End Try
    End Sub
    ' <Note>
    ' Parsing and word counting is performed on a separate thread. 
    ' This way the main UI thread doesn't get blocked during the operation and the form 
    ' doesn't get blanked out when it requires an update.
    ' However, starting with VS 2003, you can't access form controls from a thread different from the 
    ' one they were created in. It is enforced by the runtime and any attempt to invoke 
    ' control methods from a different thread results in exception. To perform cross-threaded operations 
    ' it is necessary to define delegates for the methods you want to invoke and use the control
    ' Invoke() method to queue the invocation to the original thread context.
    ' The delegates used by the parsing thread are defined below:
    ' </Note>
    Private Delegate Sub SetRunButtonStateDelegate_t(ByVal Enable As Boolean)
    Private Delegate Sub ShowResultsDelegate_t()
    Private SetRunButtonStateDelegate As SetRunButtonStateDelegate_t = New SetRunButtonStateDelegate_t(AddressOf SetRunButtonState)
    Private ShowResultsDelegate As ShowResultsDelegate_t = New ShowResultsDelegate_t(AddressOf ShowResults)
    '---------------------------------------------------------------------------
    ' <Summary>
    ' Form loading event.
    ' Some basic initialization happens here.
    ' If you need additional initialization, this is a good place to put it.
    '</Summary>
    Private Sub FormVSLDemo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        wc = New WordCount.WordCount()              ' Create the word counter
        If (Rational.PureAPI.IsRunning()) Then
            Rational.PureAPI.AddAnnotation("This is a VS Live demo run")
            CheckUsePureAPI.Enabled = True
        Else
            CheckUsePureAPI.Enabled = False
        End If
    End Sub

    '---------------------------------------------------------------------------
    ' <Summary>
    ' Run file dialog for selecting the file to process
    ' </Summary>
    Private Sub RunFileDialog()
        If CheckUsePureAPI.Checked Then
            Rational.PureAPI.StopRecordingData()
        End If
        OpenFileDialog.ShowDialog()
        TextPath.Text = OpenFileDialog.FileName
    End Sub

    '---------------------------------------------------------------------------
    ' <Summary>
    ' File processing initialization.
    ' The processing will happen later on the parsing thread.
    ' </Summary>
    Private Sub ProcessFile()
        TimerUI.Enabled = False
        ProgressCount.Value = 0
        ListViewWords.Items.Clear()
        Try
            ' Clear old results
            PanelBytes.Text = "0"                       ' Reset the bytes counter panel
            PanelWords.Text = "0"                       ' Reset the words counter panel
            ' Open the selected file
            fs = New IO.FileStream(TextPath.Text, IO.FileMode.Open, IO.FileAccess.Read)
            FileSize = fs.Length
            PanelTotal.Text = FileSize.ToString()
            TimerUI.Enabled = True
            TimerUI.Start()
            ParsingThread = New Threading.Thread(AddressOf ParsingThreadEntry)
            ParsingThread.Start()
        Catch ex As Exception
            ' Something's wrong with the file
            MsgBox("Can't open file: " + TextPath.Text + " Check the name and try again")
            Return
        End Try
    End Sub

    '---------------------------------------------------------------------------
    ' <Summary>
    ' Parsing thread entry
    ' This is where the parsing and word counting happens.
    ' The actual job is done by the WordCount class implemented in C#
    ' so we can see some cross-language profiling here.
    ' Also note that most PureAPI invocations are fired from this method
    ' </Summary>
    Private Sub ParsingThreadEntry()
        Dim args() As Object = {False}
        ButtonRun.Invoke(SetRunButtonStateDelegate, args)
        timeStart = New TimeSpan(DateTime.Now.Ticks)
        ' Check the PureAPI status  
        If CheckUsePureAPI.Checked Then
            Rational.PureAPI.ClearData()                ' Clear previous counters
            Rational.PureAPI.StartRecordingData()       ' Start recording now
        End If

        ' Parsing
        Try
            wc.Parse(fs)                                ' Do the magic
        Catch ex As Threading.ThreadAbortException
            fs.Close()                                  ' Close the file
            Return
        Catch ex As Exception
            ' Something's wrong with the file
            MsgBox("OOPS... Exeption processed: " + ex.ToString())
            Return
        End Try
        ' Check the PureAPI status
        If CheckUsePureAPI.Checked Then
            Rational.PureAPI.StopRecordingData()        ' Stop recording
            Rational.PureAPI.SaveData()                 ' Do the snapshot
        End If
        ' Show Results
        Invoke(ShowResultsDelegate)
        ' Cleanup
        fs.Close()                                      ' Close the file
        TimerUI.Stop()                                  ' Stop timer
        args(0) = True
        ButtonRun.Invoke(SetRunButtonStateDelegate, args)
    End Sub

    Private bSortWords As Boolean = True
    '---------------------------------------------------------------------------
    Private Sub SortByWords()
        ListViewWords.ListViewItemSorter = wsort
        If (bSortWords) Then
            bSortAscending = Not bSortAscending
            ListViewWords.Sort()
        End If
        bSortWords = True
    End Sub
    '---------------------------------------------------------------------------
    Private Sub SortByFrequences()
        ListViewWords.ListViewItemSorter = fsort
        If (Not bSortWords) Then
            bSortAscending = Not bSortAscending
            ListViewWords.Sort()
        End If
        bSortWords = False
    End Sub

    '---------------------------------------------------------------------------
    Private Sub FixPerformance()
        bFixPerformance = Not bFixPerformance
        CheckFixPerformance.Checked = bFixPerformance
        wc.bFixPerformance = bFixPerformance
        ListViewWords.Sort()
    End Sub

    '---------------------------------------------------------------------------
    Private Sub FixLeaks()
        bFixLeaks = Not bFixLeaks
        CheckFixLeaks.Checked = bFixLeaks
        wc.bFixLeaks = bFixLeaks
    End Sub

    '---------------------------------------------------------------------------
    ' Well, this is a small example of 'problematic code'
    ' which is also not tested properly. You should see the code below
    ' clearly marked as 'not covered' unless you made a mistake and pressed this 
    ' "Trap Checkbox"
    Private Sub DontForget()
        ' That's what we programmers usually put in comments:
        ' Not implemented yet
        ' I promise I will do it by the release time
        '
        Debug.Assert(False)
    End Sub

    '---------------------------------------------------------------------------
    ' <Summary>
    ' Unexpected exit handling.
    ' Since the processing is done on a separate thread
    ' it just terminates this thread and nothing bad happens.
    ' The industrial strength implementation should do some cleanup as well.
    ' </Summary>
    Private Sub FormVSLDemo_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ' Guess you don't want to wait it to finish
        If Not ParsingThread Is Nothing Then
            If ParsingThread.IsAlive Then
                ParsingThread.Abort()
            End If
        End If
    End Sub
    ' Event handlers below this line ===========================================
    ' Most of the event handlers are trivial and do not require comments
    ' All non-trivial operations defined in the code above.
#Region " Event Handlers "

    '---------------------------------------------------------------------------
    Private Sub ButtonSelPath_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSelPath.Click
        RunFileDialog()
    End Sub


    '---------------------------------------------------------------------------
    Private Sub ButtonRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRun.Click
        ProcessFile()
    End Sub

    '---------------------------------------------------------------------------
    Private Sub CheckFixPerformance_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckFixPerformance.Click
        FixPerformance()
    End Sub

    '---------------------------------------------------------------------------
    Private Sub CheckFixLeaks_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckFixLeaks.Click
        FixLeaks()
    End Sub

    '---------------------------------------------------------------------------
    Private Sub ListViewWords_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles ListViewWords.ColumnClick
        If e.Column = 0 Then
            SortByWords()
        Else
            SortByFrequences()
        End If
    End Sub

    '---------------------------------------------------------------------------
    ' Drag and drop files (sorry, only single selection supported)
    Private Sub ListViewWords_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ListViewWords.DragDrop
        TextPath.Text = e.Data.GetData("FileName")(0)
        ProcessFile()
    End Sub

    Private Sub ListViewWords_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ListViewWords.DragEnter
        If (e.Data.GetDataPresent("FileName")) Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    Private Sub TimerUI_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerUI.Tick
        ProgressCount.Value = Convert.ToDouble(wc.GetnBytes()) * 100 / FileSize
        PanelBytes.Text = wc.GetnBytes().ToString()
        PanelWords.Text = wc.GetnWords().ToString()
    End Sub

    Private Sub CheckClickMe_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckClickMe.CheckedChanged
        DontForget()
    End Sub
#End Region

End Class
'= End of FormVSLDemo ==========================================================
