#
# (C) Copyright IBM Corporation. 2008, 2008. All Rights Reserved.
#  
# 2008-09-08 Version 1.04
# 

$cmd             = "ScanVC6ForPurifyPlus.pl";
$cmdversion	 = "v1.04";
$fileVerified	     = 0;
$runtime=time();
$tempfile="$runtime.txt";
$yesdsw=1;
$cwddir=`cd`;
chomp $cwddir;
#
my $i = 0;
# Parse options
while (defined $ARGV[$i]) {
	if ($ARGV[$i] !~ m/-dsw=|-dsp=|-config=|-report=|-write=/){ Usage();}
	if ($ARGV[$i]=~ m/^-dsw=(.*)/){
		$opt_dsw=$1;
	}elsif ($ARGV[$i]=~ m/-dsp=(.*)/){
		$opt_dsp=$1;
	}elsif ($ARGV[$i]=~ m/-config=(.*)/){
		$opt_config=$1;
	}elsif ($ARGV[$i]=~ m/-report=(.*)/){
		$opt_report=$1;
	}elsif ($ARGV[$i]=~ m/-write=(.*)/){
		$opt_write=$1;
	}
 $i++;
}
$wodsw=0;
$wodsp=0;
if (!$opt_dsw )  {
	$wodsw=1;
	$command="perl $0";
}else { 
	 $inputFile=$opt_dsw;
	 $command="perl $0 -dsw=$inputFile";
	if ($inputFile !~ m/\.dsw/i) {$yesdsw=0;}
}
if (!$opt_dsp ) {
	$wodsp=1;
}else {  
	$proj=$opt_dsp;
	$command="$command -dsp=$proj";
}
if (!($wodsw xor $wodsp)){ Usage();}
if (!$opt_config ) {
	$config=$Pconfig="all";
}else {
	$Pconfig=$opt_config;
	$command="$command -config=$Pconfig";
	$config ="\L$Pconfig";
}
if (!$opt_report )  {
	$printmode=0;
} else {
	$logFile=$opt_report;
	$command="$command -report=$logFile";
	$printmode=1;
}
if (!$opt_write ) {
	$write =0;
	$a=$Pa="no";
} else {
   	$Pa=$opt_write;
	$command="$command -write=$Pa";
	$a ="\L$Pa";
 	if ($a eq "yes") { $write=1;}	 
}
if ($config eq "all") {$allconfig=1;} else {$allconfig=0;}
#verify inputs
if ($printmode){ 
	open(OUTFILE, ">$logFile") || die printlog ("Cannot open report file $logFile: $!",$printmode, 2,1,1);
	printlog("$cwddir>$command", $printmode, 2);
}
printlog ("Version: $0 $cmdversion", $printmode, 2,1);
printlog ("Scan dsw file = $inputFile",$printmode, 1,1);
printlog ("..........dsp = $proj",$printmode, 1,1);
printlog ("Configuration = $Pconfig",$printmode, 1,1);
printlog (".......report = $logFile" ,$printmode, 1,1);
printlog ("........write = $Pa",$printmode, 2,1);

if (!$wodsw){
$myPath = $inputFile =~ m/(.*)[\/\\]/ ? $1 : "";
#
    if(!$yesdsw){
    	printlog($_, $printmode, 1);
	printlog("$inputFile is not a valid Visual Studio workspace file", $printmode, 1,1);
	exit 1;
    }

open(INFILE, $inputFile) || die printlog ("Cannot open workspace file $inputFile: $!",$printmode, 1,1,1);
LINE: while (<INFILE>) {
    chomp;
    if( $fileVerified == 0 ) {
	&IsDSWFile();
	$fileVerified = 1;
	next LINE;
    }
    #  Look for Project section and parse, building array of all project files
    if( m/^Project:/ ) {
	($F1, $ProjFile, $F2,$F3) = split / /, $_, 4;
	for ($ProjFile) {
 	     s/\=".\\/\=/;
 	     s/\=.\\/\=/;
#            s/^\s+//;
             s/"//g;
	     m/(.*)=(.*)/ ;
	     $ProjFile=$2;
	}
	push @ProjFileList, join '', $myPath, '\\', $ProjFile;
    }
}
close INFILE;
}else{
	push @ProjFileList, $proj;
}
@ProjFileList= reverse @ProjFileList;
		ProcessProjectFile();

close OUTFILE;

if (-e "$tempfile"){ `del $tempfile `;}

exit 0;
############################################################
sub IsDSWFile {
    ($VSDSW, $FormatVersion) = split /,/, $_, 2;
    if(( "$VSDSW" eq "Microsoft Developer Studio Workspace File" ) && ($yesdsw)){
    	printlog($_, $printmode, 1);
    	if( $FormatVersion !~ m/(6.00)$/ ) {
		printlog("$FormatVersion is an unknown version. trying to analyze anyway",$printmode,1,1);
	}
    }else{
	printlog("$inputFile is not a valid Visual Studio workspace file", $printmode, 1,1);
	exit 1;
    }
}

sub ProcessProjectFile {
$wrongconf=1;
if (!$wodsw){$stdout=0;}else{$stdout=1;}

    while( $fname = pop @ProjFileList ) {
	open(TMPFILE, ">$tempfile") || die printlog ("Cannot open temp file $tempfile: $!",$printmode, 1,1,1);
	open(PROJFILE, $fname)  || die printlog ("Cannot open project file $fname: $!",$printmode, 1,1,1);
($BackupProj)      = $fname =~ m/([^\/\\]+)$/;
($Backupdir)       = $fname =~ m/(.*)[\/\\]/ ? $1 : "";
$yesconfig=0;
$done=0;
$next=0;
$endconf=0;
$error=0;
$skipproj=1;
$printproj=0;
	LINE: while(<PROJFILE>) {
$release=0;
		if ($done){
		    $done=0;
		    $next=1;
		    $nextline=$_;
		    $_=$conf;
		}
	    #  Look for Project Version
		
 	if (m/Microsoft Developer Studio Project File/){
		($F1, $projname, $F2) = split /"/, $_, 3;
		print TMPFILE "$_";
		next LINE;
	}elsif( m/version/i ) {
		($F1, $projversion) = split /,/, $_, 2;
		chomp $projversion;
		print TMPFILE "$_";
		next LINE;
    	    }
	    #  Look for Project type and log it
	    elsif( m/TARGTYPE (.*)/i ) {
		$ProjType = $1;
		chomp $ProjType;
		print TMPFILE "$_";
		if ($ProjType =~ /win32/i) {$skipproj=0;}
		printlog("\n--------------------------------------------------", $printmode, 1);
		printlog("Project name = $projname", $printmode, 1);
		printlog("Project file = $fname", $printmode, 1);
#		printlog("ProjectVersion = $projversion", $printmode, 1);
		printlog("TARGETTYPE = $ProjType", $printmode, 1);
		$printproj=1;
		if ($skipproj) {
			printlog("\nSettings not checked for this project.",$printmode,1);
			last LINE;
		}

#		printlog("\n(CFG) = $Configuration ", $printmode, 1);
		next LINE;
    	    }

	    #  Look for Configuration and log it
	    elsif ( m/CFG/ && !m/!MESSAGE/) {
		print TMPFILE "$_";
		if ( m/CFG=/){
			($F1,$F2,$pform, $PConfiguration) = split / /, $_, 4;
			for ($PConfiguration) {	s/"//;}
			chomp $PConfiguration;
			$Configuration="\L$PConfiguration";
			if ($PConfiguration =~ /Release/i){ $release=1;	}
		}
		if (( m/\(CFG\)/ ) &&(!$endconf)){
			($F1,$F2,$F3,$F4,$F5,$F6,$pform, $PConfiguration) = split / /, $_, 8;
			for ($PConfiguration) { s/"//;}
			chomp $PConfiguration;
			$Configuration="\L$PConfiguration";
			if ($PConfiguration =~ /Release/i){$release=1;}	else {$release=0;}
			if (($Configuration eq $config) || ( $allconfig)){
 				$yesconfig++;
				$wrongconf=0;
				printlog("\nConfiguration = $PConfiguration",$printmode,1);
			}
			if ($next) {print TMPFILE "$nextline"; $next=0; }
			ProcessConfiguration();
		}
   	    }elsif ( m/# PROP BASE/ ) {
			print TMPFILE "$_";
			if (($Configuration eq $config) || ( $allconfig)){
 				$yesconfig++;
				$wrongconf=0;
				printlog("\nConfiguration = $PConfiguration",$printmode,1);
			}
			if ($next) {print TMPFILE "$nextline"; $next=0; }
			ProcessConfiguration();

   	    }else{
		print TMPFILE "$_";
		if ($next) {print TMPFILE "$nextline"; $next=0; }
	    }


#LINE-end
	}
	close PROJFILE;
	close TMPFILE;
#
	if (!$printproj){
		printlog("\n--------------------------------------------------", $printmode, 1);
		printlog("Project name = $projname", $printmode, 1);
		printlog("Project file = $fname", $printmode, 1);
		if ($skipproj) {
			printlog("\nSettings not checked for this project.",$printmode,1);
		}
	}
    	if (!$skipproj){
	   if (!$yesconfig){
		printlog("\nCan't find Configuration=$Pconfig in dsp=$projname",$printmode,1,$stdout);
	   }elsif ($error == 0)  {
		printlog("\nProject/Configuration settings are correct.",$printmode,1);
	   }elsif (($write) ) {
		printlog("...................................",$printmode,1);
		if ($error ==1){
			printlog("There is $error incorrect Setting...",$printmode,1);
		}else{
			printlog("There are $error incorrect Settings...",$printmode,1);
		}
		if (-e "$fname.backup") {
			printlog ("$BackupProj.backup already exists, skipping backup.", $printmode,1);
		}else{
			printlog("Copying original project file to $BackupProj.backup",$printmode,1);
			$sta=		`ATTRIB +A -R "$fname.backup"`;
			$sta=		`copy /Y  "$fname" "$fname.backup"`;
 			#print "copy $fname to $fname.backup status =$sta....\n";
		}
		printlog("Writing new project file: $BackupProj...",$printmode,1);
		$sta=		`ATTRIB +A -R "$fname"`;
		$sta=		`copy /Y  "$tempfile" "$fname"`;
		#print "Copy $tempfile to $fname status =$sta...\n\n";
	   }
	}

#While-end
    }
if (($wrongconf)&&(!$skipproj)&&(!$wodsw)){
 		printlog("\n--------------------------------------------------",$printmode,1);
		printlog("\nCan't find configuration=$Pconfig in workspace file=$inputFile",$printmode,1,1);
}
#sub-end
}

sub ProcessConfiguration {
#hold write tempfile
	$writeline=0; 
# CPP checkpoint
	$yesZiBase=0; 
	$yesOdBase=0; 
	$yesZi=0; 
	$yesOd=0; 
	$yesZiSub=0; 
	$yesOdSub=0; 
# CPP line $basecpp, $cpp, $subcpp
	$yesbasecpp=0;
	$yescpp=0;
	$yessubcpp=0;
	$writecpp=0;
#LINK 32 checkpoint
	$yesincBase=0;
	$noincBase=0;
	$yesfixBase=0;
	$yespdbBase=0;
	$yesdebBase=0;
	$yesdetypeBase=0;
	$yesinc=0;
	$yesfix=0;
	$yespdb=0;
	$yesdeb=0;
	$yesdetype=0;
	$yesincSub=0;
	$yesfixSub=0;
	$yespdbSub=0;
	$yesdebSub=0;
	$yesdetypeSub=0;
#LINK 32 line $baselink, $link, $sublink
	$yesbaselink=0;
	$yeslink=0;
	$yessublink=0;
	$writelink=0;
$Zerror=0;
$Oerror=0;
$ierror=0;
$ferror=0;
$perror=0;
$derror=0;
$terror=0;
    LINE: while(<PROJFILE>) {
	if (m/!E/ || m/# Begin Target/){
	        $done=1;
		$conf=$_;
		if (m/!END/ || m/# Begin Target/) {$endconf=1}
# 		last LINE;
	}
#	chomp $_;
	if (/# ADD BASE CPP/){
		if (/\/Zi/) { $yesZiBase=1;}
		if (/\/Od/) { $yesOdBase=1;}
		$basecpp=$_;
		$yesbasecpp=1;
		$writecpp=1;
	}elsif( /# ADD CPP/ ) {
		if (/\/Zi/) { $yesZi=1;}
		if (/\/Od/) { $yesOd=1;}
		$cpp=$_;
		$yescpp=1;
		$writecpp=1;
	}elsif( /# SUBTRACT CPP/ ) {
		if (/\/Zi/) { $yesZiSub=1;}
		if (/\/Od/) { $yesOdSub=1;}
		$subcpp=$_;
		$yessubcpp=1;
		$writecpp=1;
	}elsif (/# ADD BASE LINK32/){
		if (/incremental:no/i) { $yesincBase=1;}
		if (/fixed:no/i) { $yesfixBase=1;}
		if (/pdbtype:sept/) { $yespdbBase=1;}
		if ((/\/debug /i) || (/\/debug\n/i)){ $yesdebBase=1;}
		if ((/\/debugtype:coff/i)||(/\/debugtype:both/i)) { $yesdetypeBase=1;}
		$baselink=$_;
		$yesbaselink=1;
		$writelink=1;
	}elsif( /# ADD LINK32/ ) {
		if (/incremental:no/i) { $yesinc=1;}
		if (/fixed:no/i) { $yesfix=1;}
		if (/pdbtype:sept/) { $yespdb=1;}
		if ((/\/debug /i) || (/\/debug\n/i) ){ $yesdeb=1;}
		if ((/\/debugtype:coff/i)||(/\/debugtype:both/i)) { $yesdetype=1; }
		$link=$_;
		$yeslink=1;
		$writelink=1;
	}elsif( /# SUBTRACT LINK32/ ) {
		if (/incremental:no/i) { $yesincSub=1;}
		if (/incremental:yes/i) { $noincSub=1;}
		if (/fixed:no/i) { $yesfixSub=1;}
		if (/pdbtype/) { $yespdbSub=1;}
		if ((/\/debug /i) || (/\/debug\n/i)) { $yesdebSub=1;}
		if ((/\/debugtype:coff/i)||(/\/debugtype:both/i)) { $yesdetypeSub=1;}
		$sublink=$_;
		$yessublink=1;
		$writelink=1;
	}else {
		writeback();
		if ($done){ last LINE;}
		else {
			print TMPFILE "$_";
		}
	}
#LINE-end
	}
#sub-end
}

sub writeback
{
#write back CPP part
	if ($writecpp){
		if ($yesZiSub) {
			$subcpp =~ s/\/Zi//;
		    	$Zerror=1;
		}
#		if ((!$yesZi) && (!$yesZiBase) &&($yescpp)) {
		if ((!$yesZi) &&($yescpp)) {
#RATLC01236392
$addZi=1;
			chomp $cpp;
			@cpp = split (/ /, $cpp);
			for ($cppcnt=0; $cppcnt <= $#cpp; $cppcnt++){
			       if ((@cpp[$cppcnt] eq "/Zd") || (@cpp[$cppcnt] eq "/Z7") || (@cpp[$cppcnt] eq "/ZI") )
				{
					@cpp[$cppcnt]="/Zi";
		    			$Zerror=1;
					$addZi=0;
				}
			}
			if ($addZi){
				@cpp[$#cpp+1]="/Zi";
		    			$Zerror=1;
			}
			$cpp="@cpp\n";
		}
	    if ($release){
		if ($yesOdSub) {
			$subcpp =~ s/\/Od//;
		    	$Oerror=1;
		}
#		if ((!$yesOd) && (!$yesOdBase) &&($yescpp)) {
		if ((!$yesOd) && ($yescpp)) {
$addOd=1;
			chomp $cpp;
			@cpp = split (/ /, $cpp);
			for ($cppcnt=0; $cppcnt <= $#cpp; $cppcnt++){
			       if ((@cpp[$cppcnt] =~ /\/O(\w+)/i) && (@cpp[$cppcnt] !~ /(Ob1|Ob2)/) )
				{
					if ($addOd){
						@cpp[$cppcnt]="/Od";
		    				$Oerror=1;
						$addOd=0;
					}else{
						@cpp[$cppcnt]="";
					}

				}
			}
			if ($addOd){
				@cpp[$#cpp+1]="/Od";
		    			$Oerror=1;
			}
			$cpp="@cpp\n";
		}
	    }
		if ($yesbasecpp){ print TMPFILE "$basecpp";}
 		if ($yescpp) 	{ print TMPFILE "$cpp";}
		if ($yessubcpp)	{ print TMPFILE "$subcpp";}
		if ($Zerror){
		    	printlog("Incorrect Setting: Debug info needs to be set to: Program Database in the C/C++ tab, General category.", $printmode, 1);
			$error++;
		}
		if ($Oerror){
			printlog("Incorrect Setting: Optimizations field needs to be set to: Disable(Debug) in the C/C++  tab, General category.", $printmode, 1);
			$error++;
		}
		$writecpp=0;
	}elsif ($writelink){
		if (!$noincSub) {
			if ($yesincSub) {
				$sublink =~ s/\/incremental:no//;
		    		$ierror=1;
			}
			if ((!$yesinc) && ($yeslink)) {
				if ($link =~ /\/incremental:(\w+)/i)
				{
					$link="$`/incremental:no$'";
		    			$ierror=1;
				}else{
					chomp $link;
					$link="$link /incremental:no\n";
		    			$ierror=1;
				}
			}
		}
		if ($yesfixSub) {
			$sublink =~ s/\/fixed:no//;
		    	$ferror=1;
		}
		if ((!$yesfix) && ($yeslink)) {
			if ($link =~ /\/fixed:(\w+)/i)
			{
				$link="$`/fixed:no$'";
		    		$ferror=1;
			}else{
				chomp $link;
				$link="$link /fixed:no\n";
		    		$ferror=1;
			}
		}
		if (!$yespdbSub) {
			if (($yespdb) && ($yeslink)){
				$link =~ s/\/pdbtype:sept//;
		    		$perror=1;
			}#elsif ($yespdbBase){
#		    		$perror=1;
#				if ($yessublink){
#					$sublink="$sublink /pdbtype:sept";
#				}else {
#					$sublink="# SUBTRACT LINK32 /pdbtype:sept";
#					$yessublink=1;
#				}
#			}
 		}
		if ($yesdebSub) {
			$sublink =~ s/\/debug //;
			$sublink =~ s/\/debug\n/\n/;
		    	$derror=1;
		}
#		if ((!$yesdeb) && (!$yesdebBase) && ($yeslink)) {
		if ((!$yesdeb) && ($yeslink)) {
			chomp $link;
			$link="$link /debug\n";
		    	$derror=1;
		}
#
		if ($yesdetypeSub) {
			$sublink =~ s/\/incremental:no//;
			$sublink =~ s/ \/debugtype:coff//;
			$sublink =~ s/ \/debugtype:both//;
		  		$terror=1;
		}
		if (($yesdetype) && ($yeslink)){
			$link =~ s/ \/debugtype:coff//;
			$link =~ s/ \/debugtype:both//;
		    	$terror=1;
		}
 		
		if ($yesbaselink)	{ print TMPFILE "$baselink";}
 		if ($yeslink) 		{ print TMPFILE "$link";}
		if ($yessublink)	{ print TMPFILE "$sublink";}
		if ($ierror){
			printlog("Incorrect Setting: Link Incrementally needs to not be checked in the Link tab, General category.", $printmode, 1);
			$error++;
		}
		if ($ferror){
			printlog("Incorrect Setting: /fixed:no needs to be added to Project Options in the Link tab, General category.", $printmode, 1);
			$error++;
		}
		if ($perror){
			printlog("Incorrect Setting: Separate types needs to not be checked in  the Link tab, Debug category.", $printmode, 1);
			$error++;
		}
		if ($derror){
			printlog("Incorrect Setting: Generate debug info needs to be checked in the Link tab, General category.", $printmode, 1);
			$error++;
		}
		if ($terror){
			printlog("Incorrect Setting: Microsoft format needs to be selected in Debug Info in the Link tab, Debug category.", $printmode, 1);
			$error++;
		}
		$writelink=0;
	    }
#sub-end
}

sub printlog()
{
	my ($printstr, $pmode, $lf, $sout,$end)=@_;
#$printstr=print string
#$pmode= printmode 0=console, 1=output-file
#$lf=linefeed,
#$sout=stand output also, 0=no, 1=yes
#$end=end of program 1=end
	if ($pmode) {
		print OUTFILE $printstr;
		for ($i=1; $i<=$lf; $i++){
			print OUTFILE "\n";
		}
		if($sout){
			print $printstr;
			for ($i=1; $i<=$lf; $i++){
			print "\n";
			}
		}
	}else{
		print $printstr;
		for ($i=1; $i<=$lf; $i++){
			print "\n";
		}
	}
	if ($end){
		if (-e "$tempfile"){
			close TMPFILE;
 			 `del $tempfile `;
		}
		exit 1;
	}

}
sub Usage()
{
	print "$cmdversion Usage:\n";
	print "perl $0  [<options>] \n";
	print "Options:\n";
	print " -dsw=<workspace-file> ==> specify a workspace file to check or modify\n";
	print "                       You must specify a workspace file or a project file\n";
	print " -dsp=<project-file> ==> specify the project file to check or modify\n";
	print " -config=<Configuration | all>\n";
	print "       config=Configuration  ===> only scan the specified configuration\n";
	print "       config=all (default) ==> scan all configurations\n";
	print " -report=<output file> Specify the output file\n";
	print "       (default)=output to console\n";
	print " -write=<yes> Modify settings and write. \n";
	print "        It is recommended that you backup the projects before modifying.\n";
	print "        write=yes ==> modify settings and write project file(s) after\n";
	print "                      saving current project file(s) to <projectFile>.backup.\n";
	print "        write=no (default)==> report incorrect settings only, \n";
	print "                              don't modify anything.\n";
	print "e.g. perl $0 -dsw=\"C:\\My Apps\\MyCode.dsw\" -report=scan.log -write=yes\n";
	print "or   perl $0 -dsp=C:\\MyApps\\MyCode.dsp -report=scan.log -write=yes\n";
	exit 1;
}

__END__
