#
# (C) Copyright IBM Corporation. 2008, 2009. All Rights Reserved.
#  
# 2009-2-24 Version 1.08
# 

$cmd            = "ScanVSSolutionForPurifyPlus.pl";
$cmdversion	= "v1.08";

$fileVerified	     = 0;
$runtime=time();
$tempfile="$runtime.txt";
$yessln=1;
$cwddir=`cd`;
chomp $cwddir;
%pt=(	"vcproj" 	=>	"Visual C++",
	"vbproj" 	=>	"VisualBasic",
	"vjsproj"	=>	"VISUALJSHARP",
	"csproj"	=>	"CSHARP"
	);
my $i = 0;
# Parse options
while (defined $ARGV[$i]) {
	if ($ARGV[$i] !~ m/-sln=|-proj=|-config=|-report=|-write=/){ Usage();}
	if ($ARGV[$i]=~ m/^-sln=(.*)/){
		$opt_sln=$1;
	}elsif ($ARGV[$i]=~ m/-proj=(.*)/){
		$opt_proj=$1;
	}elsif ($ARGV[$i]=~ m/-config=(.*)/){
		$opt_config=$1;
	}elsif ($ARGV[$i]=~ m/-report=(.*)/){
		$opt_report=$1;
	}elsif ($ARGV[$i]=~ m/-write=(.*)/){
		$opt_write=$1;
	}
 $i++;
}
#
$wosln=0;
$woproj=0;
if (!$opt_sln )  {
	$wosln=1;
	$command="perl $0";
}else { 
	$inputFile=$opt_sln;
	$command="perl $0 -sln=$inputFile";
	if ($inputFile !~ m/\.sln/i) {$yessln=0;}
}
if (!$opt_proj ) {
	$woproj=1;
}else {  
	$proj=$opt_proj;
	$command="$command -proj=$proj";
}
if (!($wosln xor $woproj)){ Usage();}
if (!$opt_config ) {
	$config=$Pconfig="all";
}else {
	$Pconfig=$opt_config;
	$command="$command -config=$Pconfig";
	$config ="\L$Pconfig";
}
if (!$opt_report )  {
	$printmode=0;
} else {
	$logFile=$opt_report;
	$command="$command -report=$logFile";
	$printmode=1;
}
if (!$opt_write ) {
	$write =0;
	$a=$Pa="no";
} else {
   	$Pa=$opt_write;
	$command="$command -write=$Pa";
	$a ="\L$Pa";
	if ($a !~ /yes|no/) { Usage();}
 	if ($a eq "yes") { $write=1;}	 
}
if ($config eq "all") {$allconfig=1;} else {$allconfig=0;}

#verify inputs
if ($printmode){ 
	open(OUTFILE, ">$logFile") || die printlog("Cannot open report file $logFile: $!", $printmode, 1,1,1);
	printlog("$cwddir>$command", $printmode, 2);
}
printlog ("Version: $0 $cmdversion", $printmode, 2,1);
printlog ("Scan solution file = $inputFile",$printmode, 1,1);
printlog ("...........project = $proj",$printmode, 1,1);
printlog ("............config = $Pconfig",$printmode, 1,1);
printlog ("............report = $logFile" ,$printmode, 1,1);
printlog (".............write = $Pa",$printmode, 2,1);

if (!$wosln){
$myPath =$inputFile =~ m/(.*)[\/\\]/ ? $1 : "";
#get current dir
if ($myPath eq "") { $myPath=`echo %cd%`; chomp $myPath;}
$line=0;
$error=0;
   if(!$yessln){
   	printlog($_, $printmode, 1);
	printlog("$inputFile is not a valid Visual Studio solution file", $printmode, 1,1);
 	exit 1;
  }

open(INFILE, $inputFile) || die printlog("Cannot open solution file $inputFile: $!", $printmode, 1,1,1);
LINE: while (<INFILE>) {
	chomp;
	if ( (  !m/Microsoft/) && ($line == 0) ){
		next LINE
	}
		$line++;
  	if( $fileVerified == 0 ) {
		&IsSolutionFile();
		$fileVerified = 1;
		next LINE;
    	}
#  Look for Project section and parse, building array of all project files
    	if( m/^Project\("/ ) {
		($F1, $ProjFile, $F2) = split /,/, $_, 3;
		for ($ProjFile) {
            	s/^\s+//;
            	s/"//;
            	s/"$//;
	}
	push @ProjFileList, join '', $myPath, '\\', $ProjFile;
  }
}
close INFILE;

}else {
	push @ProjFileList, $proj;
}
@ProjFileList= reverse @ProjFileList;
	ProcessProjectFile();

close OUTFILE;
#remove temp file
if (-e "$tempfile"){ `del $tempfile `;}

exit 0;
############################################################
sub IsSolutionFile {
    ($VSSolution, $FormatVersion) = split /,/, $_, 2;
    if(( "$VSSolution" eq "Microsoft Visual Studio Solution File" ) && ($yessln)){
    	printlog($_, $printmode, 1);
    	if( $FormatVersion !~ m/[7.00|8.00|9.00|10.00]$/ ) {
		printlog("$FormatVersion is an unknown version. trying to analyze anyway",$printmode,1,1);
	}
    }else{
	printlog("$inputFile is not a valid Visual Studio solution file", $printmode, 1,1);
	exit 1;
    }
}

sub ProcessProjectFile {
$wrongconf=1;
if (!$wosln){$stdout=0;}else{$stdout=1;}
   while( $fname = pop @ProjFileList ) {
	$error=0;
#define which type  of project
#  vb/cs/vjs    others    vc 
   	$notvcproj=$skipproj=$yesvcproj=0;
	if ($fname =~ /\.vcproj/){
		$yesvcproj=1;
	}elsif ($fname =~ /\.vbproj|\.csproj|\.vjsproj/){
		$notvcproj=1;
	}else {
		$skipproj=1;
	}
($BackupProj)      = $fname =~ m/([^\/\\]+)$/;
($Backupdir)       = $fname =~ m/(.*)[\/\\]/ ? $1 : "";
$ptype=$BackupProj =~ m/\.(.*)/ ? $1 : ""; 

#reset proj/config selection
	$yesconfig=0;
	$manged=0;
	$keyword="";	
	$pform="";
	if ($yesvcproj) {
		scanvcproj();
	}elsif( $notvcproj) {
		open(PROJFILE, $fname)  || die printlog("Cannot open project file $fname: $!", $printmode, 1,1,1); 
			LINE2: while(<PROJFILE>) {
	    			if(m/ProductVersion/ ){
				($F1, $projversion) = split /ProductVersion/, $_, 2;
				last LINE2;
				}
			}
			close PROJFILE;
	    if ($projversion =~ m/[8.0|9.0]/){	scannot90vcproj();}
	    else { scannotvcproj();}
	}else {
		skipproj();
	}
#
    if (!$skipproj){
	   if (!$yesconfig){
		printlog("\nCan't find Configuration=$Pconfig in project=$projname",$printmode,1,$stdout);
	   }elsif ($error == 0)  {
		printlog("\nProject/Configuration settings are correct.",$printmode,1);
	   }elsif (($write) ) {
		printlog("...................................",$printmode,1);
		if ($error ==1){
			printlog("There is $error incorrect Setting...",$printmode,1);
		}else{
			printlog("There are $error incorrect Settings...",$printmode,1);
		}
		if (-e "$fname.backup") {
			printlog ("$BackupProj.backup already exists, skipping backup.", $printmode,1);
		}else{
			printlog("Copying original project file to $BackupProj.backup",$printmode,1);
			$sta=		`ATTRIB +A -R "$fname.backup"`;
			$sta=		`copy /Y  "$fname" "$fname.backup"`;
 			#print "copy $fname to $fname.backup status =$sta....\n";
		}
		printlog("Writing new project file: $BackupProj...",$printmode,1);
		$sta=		`ATTRIB +A -R "$fname"`;
		$sta=		`copy /Y  "$tempfile" "$fname"`;
		#print "Copy $tempfile to $fname status =$sta...\n\n";
	   }

     }

#While-end
   }

if (($wrongconf)&&(!$skipproj)&&(!$wosln)){
 		printlog("\n--------------------------------------------------",$printmode,1);
		printlog("\nCan't find configuration=$Pconfig in solution file=$inputFile",$printmode,1,1);
}	

#sub-end   
}
#1---------Scan VC project ------------------------------
sub scanvcproj 
{
@VSProline="";
@Platformline="";
@Confline="";
	open(TMPFILE, ">$tempfile") || die printlog("Cannot open temp file $tempfile: $!", $printmode, 1,1,1);
	open(PROJFILE, $fname)  || die printlog("Cannot open project file $fname: $!", $printmode, 1,1,1);
	LINE: while(<PROJFILE>) {
		print TMPFILE "$_";
	    if( m/<VisualStudioProject/ ) {
		@VSProline[0]=$_;
		if (!m/>/) { VSProinfo();}
	#1.01 get project type, version, name and keywork info 
	    	foreach $vsproline (@VSProline){
		@vsproj = split (/ /, $vsproline);
			foreach $vsproj (@vsproj){
	    			if (( $vsproj=~m/ProjectType\=/ ) && ($vsproj!~m/[A-Za-z]ProjectType\=/) ) {
					$ProjType=$pt{$ptype};
					#($F1, $ProjType) = split /=/, $vsproj, 2;
					#for ($ProjType) { s/"//g;}
					#chomp $ProjType;
   	   			}elsif( $vsproj=~m/Version\=/ && $vsproj !~ m/[A-Za-z]Version\=/) {
					($F1, $projversion) = split /=/, $vsproj, 2;
					for ($projversion) { s/"//g;}
					chomp $projversion;
				}elsif (($vsproj=~m/Name\=/) && ($vsproj!~m/[A-Za-z]Name\=/) ) {
					($F1, $projname) = split /=/, $vsproj, 2;
					for ($projname) { s/"//g;}
					chomp $projname;
	    			}elsif (($vsproj=~m/Keyword\=/)&& ($vsproj!~m/[A-Za-z]Keyword\=/) ){
					($F1, $keyword) = split /=/, $vsproj, 2;
					for ($keyword) {s/("|\/>)//g;  s/>//g;}
					chomp $keyword;
					if ($keyword =~ /ManagedCProj/){
						$manged=1;
					}
				}	
			}
	   	}#end-foreach 1.01
	    }elsif ( (m/<Platform\n/) || (m/<Platform /)){
		@Platformline[0]=$_;
		if (!m/>/) { Platforminfo();}
	#1.02 get platform info
	    	foreach $platformline (@Platformline){
			@platf = split (/ /, $platformline);
			foreach $platf (@platf){
	    			if ($platf=~m/Name/)  {
					($F1, $Platform) = split /=/, $platf, 2;
					for ($Platform) {s/("|\/>)//g;  s/>//g;}
					chomp $Platform;
	    			}
			}
	   	}#end-foreach 1.02
	#1.03 print project information
 		printlog("\n--------------------------------------------------",$printmode,1);
		printlog("Project name = $projname",$printmode,1);
		printlog("Project file = $fname",$printmode,1);
		printlog("Project Type = $ProjType, Keyword = $keyword, Version = $projversion for Platform = $Platform",$printmode,1);

	    }elsif( (m/<Configuration/i) && (!m/<Configurations>/ )) {
		@Confline[0]=$_;
		if (!m/>/) { Confinfo();}
	#1.04 get config info 
	    	foreach $confline (@Confline){
			@confl = split (/" /, $confline);
			foreach $confl (@confl){
	    			if ($confl=~m/Name=/)  {
					if ($confl=~m/\|/){
						$confl=~m/(.*)\"(.*)\|(.*)/;
						$PConfiguration="$2";
						$Configuration="\L$PConfiguration";
						$pform="\L$3";
					}else{
						$confl=~ m/(.*)\"(.*)/;
						$PConfiguration="$2";
						$Configuration="\L$PConfiguration";
					}
					if ((($Configuration eq $config) || ( $allconfig)) && ($pform !~ /win64/)){
						printlog("\nConfiguration = $PConfiguration",$printmode,1);
						ProcessConfiguration();
						$yesconfig++;
						$wrongconf=0;
						@Confline="";
						next LINE;
					}
				}
	    		}
	    	}
	    }

#LINE-end
     } 
	close PROJFILE;
	close TMPFILE;
#sub-end
}
#1.1------read < to > ----
sub VSProinfo {
	LINE: while(<PROJFILE>) {
		print TMPFILE "$_";
		push @VSProline, $_;
		if ( m/>/) { last LINE;}
	}
}
sub Platforminfo {
	LINE: while(<PROJFILE>) {
		print TMPFILE "$_";
		push @Platformline, $_;
		if ( m/>/) { last LINE;}
	}
}
sub Confinfo {
	LINE: while(<PROJFILE>) {
		print TMPFILE "$_";
		push @Confline, $_;
		if ( m/>/) { last LINE;}
	}
}
sub Toolinfo {
	LINE: while(<PROJFILE>) {
#		print TMPFILE "$_";
		push @Toolline, $_;
		if ( m/>/) { last LINE;}
	}
}


#1......
sub ProcessConfiguration {
$wpo = 0;
    LINE: while(<PROJFILE>) {
	if (m/<\/Configuration>/) {
		print TMPFILE "$_";
		last LINE;
	}
	foreach $confline (@Confline){
		@confl = split (/ /, $confline);
		foreach $confl (@confl){
			($Var, $Value) = split /=/, $confl, 2;
        		if( ($Var =~ m/WholeProgramOptimization/) && (($Value =~ m/"1"/ )||($Value =~ m/"TRUE"/i ))){
				$wpo = 1;
			}	
		}
	}

@Toolline="";
@ToolArry="";
@WToolline="";
$multiline=0;
$tcnt=0;
	if (m/<Tool/) {
		@Toolline[0]=$_;
		if (!m/>/) { $multiline=1; Toolinfo();}
	    	foreach $toolline (@Toolline){
			if (!$multiline){
				@temparry=split(/" /,$toolline);
	    				foreach $toolline2 (@temparry){
						if ($toolline2 !~ />/){
							@ToolArry[$tcnt]="$toolline2\"";
						}else{
							@ToolArry[$tcnt]=$toolline2;
						}
						$tcnt++;
					}
			}else {
				@ToolArry[$tcnt]=$toolline;
				$tcnt++;
			}
		}
@WToolline=@ToolArry;
	    	foreach $toolline (@ToolArry){
	    		if ($toolline=~m/VCCLCompilerTool/)  {
@WToolline="";
	    			ProcessCompilerSettings();
			}
	    		if ($toolline=~m/VCLinkerTool/)  {
@WToolline="";
	    			ProcessLinkerSettings();
			}
	   	}#end-foreach 
		if ($multiline){
 	    		foreach $toolline (@WToolline){ print TMPFILE "$toolline";}
		}else {
			print TMPFILE "@WToolline";
		}

	}

    }
}

sub ProcessCompilerSettings {
    $done = 0;
#   $wpo = 1;
$Optimization=1;
$DebugInformationFormat=1;
$BasicRuntimeChecks=1;
$tt1=0;
    foreach $tooll (@ToolArry){
		if( $tooll=~m/\/>/ ) {
	    		$done = 1;
			$pctemp=$tooll;
		}

		($Var, $Value) = split /=/, $tooll, 2;
	if(( $Var =~ "Optimization") && ( $Var !~ "WholeProgramOptimization") &&( $Var !~ "GlobalOptimization")) {
		$Optimization=0;
		if ($done){ Morecom();}
	    if($Value !~ m/"0"/ ) {
		printlog("Incorrect Setting: Optimization needs to be disabled in C/C++ Optimization",$printmode,1);
		$error++;
		($V1, $V2,$V3) = split /"/, $tooll, 3;
		$info ="$V1\"0\"$V3";
           	@WToolline[$tt1]=$info;
	    }else {
           	@WToolline[$tt1]=$tooll;
	    }
	}elsif( $Var =~ m/DebugInformationFormat/ ) {
		$DebugInformationFormat=0;
		if ($done){ Morecom();}
	    if($Value !~ m/"3"/ ) {
		printlog("Incorrect Setting: Debug Information Format needs to be set to Program Database (/Zi) in C/C++ General",$printmode,1);
		$error++;
		($V1, $V2,$V3) = split /"/, $tooll, 3;
		$info ="$V1\"3\"$V3";
          	@WToolline[$tt1]=$info;
	    }else {
           	@WToolline[$tt1]=$tooll;
	    }
	}elsif( $Var =~ m/BasicRuntimeChecks/ ) {
		$BasicRuntimeChecks=0;
		if ($done){ Morecom();}
	    if(($Value !~ m/"0"/ )&&(!$manged)) {
		printlog("Incorrect Setting: Basic Runtime Checks needs to be set to Default in C/C++ Code Generation",$printmode,1);
		$error++;
		($V1, $V2,$V3) = split /"/, $tooll, 3;
		$info ="$V1\"0\"$V3";
          	@WToolline[$tt1]=$info;
	    }else {
           	@WToolline[$tt1]=$tooll;
	    }
	}elsif ( ($Var =~ m/WholeProgramOptimization/) && ($projversion =~ m/[8.0|9.0]$/) ){
			$wpo = 0;
		if ($done){ Morecom();}
		if ($Value =~ m/"false"/ ) {	
           		#print TMPFILE "$_\n";
		}
		else {
			printlog("Incorrect Setting: Whole Program Optimization needs to be set to No in C/C++ Optimization",$printmode,1);
			$error++;
			($V1, $V2,$V3) = split /"/, $tooll, 3;
			$info ="$V1\"false\"$V3";
          		@WToolline[$tt1]=$info;
		}
	   	 
	}else{
		if ($done){ 
			Morecom();
			@WToolline[$tt1]=$pctemp;
		
		}else{
 			@WToolline[$tt1]=$tooll;
		}
	}
	$tt1++;
    }#end-foreach
}


sub ProcessLinkerSettings {
$done = 0;
$incrementalLinkSet = 0;
$fixedBA=0;
$LinkIncremental=1;
$GenerateDebugInformation=1;
$tt1=0;
$fixedno=1;
$fixedyes=0;
$RandomBA=1;
    foreach $tooll (@ToolArry){
		if( $tooll=~m/\/>/ ) {
	    		$done = 1;
			$pctemp=$tooll;
		}
	($Var, $Value) = split /=/, $tooll, 2;
	
	if( $Var =~ m/LinkIncremental/) {
	    	$LinkIncremental=0;
 		if ($done){ Morelink();}
	 	if (($Value !~ m/"1"/ )&& !$manged ){
			printlog("Incorrect Setting: Enable Incremental Linking needs to be set to No (/INCREMENTAL:NO) in Linker General",$printmode,1);
			$error++;
			($V1, $V2,$V3) = split /"/, $tooll, 3;
			$info ="$V1\"1\"$V3";
          		@WToolline[$tt1]=$info;
 	    	}else{
          		@WToolline[$tt1]=$tooll;
		}
 	}
 	elsif ($Var =~ m/RandomizedBaseAddress/) {
		if ($Value =~ m/"2"/ ){
 			$RandomBA=1;
		}else{
 			$RandomBA=0;
		}
	}
 	elsif ($Var =~ m/FixedBaseAddress/) {
		if ($Value =~ m/"1"/ ){
 			$incrementalLinkSet ++;
		}
		if ($Value =~ m/"2"/ ){
 			$fixedyes=1;
		}
		if ($done){
			if ((($projversion !~ m/9.0/) && !$incrementalLinkSet) || (($projversion =~ m/9.0/) && ((!$RandomBA && $fixedno && !$fixedyes)||($RandomBA && $fixedyes)) )) 
			{
				$fixedBA=1;
				Morelink();
				printlog("Incorrect Setting: Fixed Base Address needs to be set to Generate a relocation section (/FIXED:NO) in Linker Advanced",$printmode,1);
				printlog("                 : or /FIXED:no needs to be added to Additional Options in Linker Command Line",$printmode,1);
				$error++;
				($V1, $V2,$V3) = split /"/, $tooll, 3;
				$info ="$V1\"1\"$V3";
          			@WToolline[$tt1]=$info;
			}else {
				$fixedBA=1;
				Morelink();
				@WToolline[$tt1]=$tooll;
			}
		}else{
			if ((($projversion !~ m/9.0/) && !$incrementalLinkSet) || (($projversion =~ m/9.0/) && ((!$RandomBA && $fixedno && !$fixedyes)||($RandomBA && $fixedyes)) ))
			{
				$fixedno=0;
				$fixedtemp=$tooll;
          			$tt1=$tt1-1;
			}else{
				@WToolline[$tt1]=$tooll;
		     	}
		}
	}
	elsif($Var =~ m/AdditionalOptions/){
		if ($Value =~ m/FIXED\:no/i ) {
			$incrementalLinkSet ++;
		}
		if (($done) &&(!$incrementalLinkSet)){
			$fixedBA=1; 
			Morelink();
			printlog("Incorrect Setting: Fixed Base Address needs to be set to Generate a relocation section (/FIXED:NO) in Linker Advanced",$printmode,1);
			printlog("                 : or /FIXED:no needs to be added to Additional Options in Linker Command Line",$printmode,1);
			$error++;
			if ($tooll =~ m/fixed:(\w+)/i){
				$info="$`fixed:no$'";
			}else{
				($V1, $V2,$V3) = split /"/, $tooll, 3;
				$info ="$V1\"$V2 \/FIXED\:no\"$V3";
			}
          		@WToolline[$tt1]=$info;
		}		
		elsif (($done) &&($incrementalLinkSet)){
			$fixedBA=1;
			Morelink();
			@WToolline[$tt1]=$tooll;
		}else{
          		@WToolline[$tt1]=$tooll;
		}		
	}
	elsif (($Var =~ m/DelayLoadDLLs/) && ($Value !~ m/""/ )) {
		printlog("Incorrect Setting: Delay Loaded Dlls needs to clear in Linker Input",$printmode,1);
		$error++;
 		if ($done){ Morelink();}
		($V1, $V2,$V3) = split /"/, $tooll, 3;
		$info ="$V1\"\"$V3";
          	@WToolline[$tt1]=$info;
	} elsif( $Var =~ m/GenerateDebugInformation/){
		$GenerateDebugInformation=0;
 		if ($done){ Morelink();}
		if ($Value !~ m/"TRUE"/i) {
			printlog("Incorrect Setting: Generate Debug Info needs to be set to Yes in Linker Debugging",$printmode,1);
			$error++;
			($V1, $V2,$V3) = split /"/, $tooll, 3;
			$info ="$V1\"TRUE\"$V3";
          		@WToolline[$tt1]=$info=$info;
 	    	}else{
          		@WToolline[$tt1]=$tooll;
		}
 	}else{
		if ($done){
			Morelink();	
			@WToolline[$tt1]=$pctemp;
		
		}else{
 			@WToolline[$tt1]=$tooll;
		}
	}
	$tt1++;
    }#end-foreach

}

sub Morecom ()
{
	if( $Optimization ) {
$Optimization=0;
		printlog("Incorrect Setting: Optimization needs to be disabled in C/C++ Optimization",$printmode,1);
		$error++;
		$info="Optimization=\"0\"";
		if ($multiline){
          		@WToolline[$tt1]="\t\t\t\t$info\n";
		}else{
          		@WToolline[$tt1]=$info;
		}
			$tt1++;
	}
	if( $DebugInformationFormat ) {
$DebugInformationFormat=0;
		printlog("Incorrect Setting: Debug Information Format needs to be set to Program Database (/Zi) in C/C++ General",$printmode,1);
		$error++;
		$info="DebugInformationFormat=\"3\"";
		if ($multiline){
          		@WToolline[$tt1]="\t\t\t\t$info\n";
		}else{
          		@WToolline[$tt1]=$info;
		}
			$tt1++;
	}
	if(( $BasicRuntimeChecks )&&(!$manged) ) {
$BasicRuntimeChecks=0;
		printlog("Incorrect Setting: Basic Runtime Checks needs to be set to Default in C/C++ Code Generation",$printmode,1);
		$error++;
		$info="BasicRuntimeChecks=\"0\"";
		if ($multiline){
          		@WToolline[$tt1]="\t\t\t\t$info\n";
		}else{
          		@WToolline[$tt1]=$info;
		}
			$tt1++;
	}
       if ($wpo && $projversion =~ m/[8.0|9.0]$/) 	{
		printlog("Incorrect Setting: Whole Program Optimization needs to be set to No in C/C++ Optimization",$printmode,1);
		$error++;
		$info="WholeProgramOptimization=\"false\"";
		if ($multiline){
          		@WToolline[$tt1]="\t\t\t\t$info\n";
		}else{
          		@WToolline[$tt1]=$info;
		}
			$tt1++;
	}
$done=0;
}

sub Morelink ()
{
	if( $LinkIncremental && !$manged){
$LinkIncremental=0;
		printlog("Incorrect Setting: Enable Incremental Linking needs to be set to No (/INCREMENTAL:NO) in Linker General",$printmode,1);
		$error++;
		$info="LinkIncremental=\"1\"";
		if ($multiline){
          		@WToolline[$tt1]="\t\t\t\t$info\n";
		}else{
          		@WToolline[$tt1]=$info;
		}
			$tt1++;
 	}
	if( $GenerateDebugInformation){
$GenerateDebugInformation=0;
		printlog("Incorrect Setting: Generate Debug Info needs to be set to Yes in Linker Debugging",$printmode,1);
		$error++;
		$info="GenerateDebugInformation=\"TRUE\"";
		if ($multiline){
          		@WToolline[$tt1]="\t\t\t\t$info\n";
		}else{
          		@WToolline[$tt1]=$info;
		}
			$tt1++;
	}
	if ((($projversion !~ m/9.0/) && !$incrementalLinkSet && (!$fixedBA)) || (($projversion =~ m/9.0/) && ((!$RandomBA && $fixedno && !$fixedyes)||($RandomBA && $fixedyes)) && (!$fixedBA)))
	{ 
		printlog("Incorrect Setting: Fixed Base Address needs to be set to Generate a relocation section (/FIXED:NO) in Linker Advanced",$printmode,1);
		printlog("                 : or /FIXED:no needs to be added to Additional Options in Linker Command Line",$printmode,1);
		$error++;
		$info="FixedBaseAddress=\"1\"";
		$fixedno=1;
		if ($multiline){
          		@WToolline[$tt1]="\t\t\t\t$info\n";
		}else{
          		@WToolline[$tt1]=$info;
		}
		$tt1++;
		$fixedno=1;
		
	}
	if (!$fixedno) {
		@WToolline[$tt1]=$fixedtemp;
		$tt1++;
	}

$done=0;
}

#2---------Scan Non VC project ------------------------------
sub scannotvcproj {
$yesname=0;
	open(TMPFILE, ">$tempfile") || die printlog("Cannot open temp file $tempfile: $!", $printmode, 1,1,1);
	open(PROJFILE, $fname)  || die printlog("Cannot open project file $fname: $!", $printmode, 1,1,1); 
	LINE: while(<PROJFILE>) {
		print TMPFILE "$_";
#get projectype		
	$ProjType=$pt{$ptype};
	    #  Look for Project type and log it
	    if(m/ProductVersion/ ){
		($F1, $projversion) = split /=/, $_, 2;
		for ($projversion) {
	           s/"//g;
		}
		chomp $projversion;
	    }elsif ((m/AssemblyName/) && (!$yesname)){
		($F1, $projname) = split /"/, $_, 2;
			for ($projname) {
	           		s/"//g;
			}
		chomp $projname;
		$yesname=1;
 		printlog("\n--------------------------------------------------",$printmode,1);
		printlog("Project name = $projname",$printmode,1);
		printlog("Project file = $fname",$printmode,1);
		printlog("Project Type = $ProjType, Version = $projversion",$printmode,2);
	    }elsif( (m/<Config/i) && (!m/\>/ )) {
			$_ = <PROJFILE>;
			print TMPFILE "$_";

			if (m/\|/){
				m/(.*)\"(.*)\|(.*)\"/;
				$PConfiguration="$2";
				$Configuration="\L$PConfiguration";
				$pform="\L$3";
			}else{
				m/(.*)\"(.*)\"/;
				$PConfiguration="$2";
				$Configuration="\L$PConfiguration";
			}
		if ((($Configuration eq $config) || ( $allconfig)) && ($pform !~ /win64/)){
			printlog("\nConfiguration = $PConfiguration",$printmode,1);
  			ProcessConfig();
			$yesconfig++;
			$wrongconf=0;
		}
 	}

#LINE-end
     } 
	close PROJFILE;
	close TMPFILE;
}
#2.1---------
sub ProcessConfig {
$done=0;
$DebugSymbols=1;
    LINE: while(<PROJFILE>) {
	if (m/>/) {
		$done=1;
	}
	($Var, $Value) = split /=/, $_, 2;
        if ($Var =~ m/DebugSymbols/){
		$DebugSymbols=0;
	    	if($Value !~ m/"true"/ ) {
			printlog("Incorrect Setting: Generate Debug Information needs to be set to True in Build section of Configuration Properties",$printmode,1);
			$error++;
			($V1, $V2,$V3) = split /"/, $_, 3;
			$info ="$V1\"true\"$V3";
           		print TMPFILE "$info";
		}else{
            		print TMPFILE "$_";
		}
	}else{
		if (!$done){ 
           	print TMPFILE "$_";
	     }

	}
	if ($done){
#add missed line
		if ($DebugSymbols){
			printlog("Incorrect Setting: Generate Debug Information needs to be set to True in Build section of Configuration Properties",$printmode,1);
			$error++;
			$info="\t\t    DebugSymbols=\"true\"";
          		print TMPFILE "$info\n";
		}
		print TMPFILE "$_";
		last LINE;
    	}
     }
}
#3---------Scan Non 90VC project ------------------------------
sub scannot90vcproj {
$yesname=0;
	open(TMPFILE, ">$tempfile") || die printlog("Cannot open temp file $tempfile: $!", $printmode, 1,1,1);
	open(PROJFILE, $fname)  || die printlog("Cannot open project file $fname: $!", $printmode, 1,1,1);

	LINE: while(<PROJFILE>) {
		print TMPFILE "$_";
#get projectype		
	$ProjType=$pt{$ptype};
	    #  Look for Project type and log it
	    if(m/ProductVersion/ ){
		$projversion= $_ =~ m/\>(.*)\</ ? $1: "";
	    }elsif ((m/AssemblyName/) && (!$yesname)){
		$projname= $_ =~ m/\>(.*)\</ ? $1: "";
		$yesname=1;
 		printlog("\n--------------------------------------------------",$printmode,1);
		printlog("Project name = $projname",$printmode,1);
		printlog("Project file = $fname",$printmode,1);
		printlog("Project Type = $ProjType, Version = $projversion",$printmode,1);
	    }elsif( m/\<PropertyGroup Condition/) {
		$PConfiguration= $_ =~ m/==(.*)\|/ ? $1: "";
			for ($PConfiguration) {
	           		s/"//g;
	           		s/'//g;
	           		s/ //g;
			}
			$pform= $_ =~ m/==(.*)\|(.*)\'/ ? $2: "";
			$Configuration="\L$PConfiguration";
			if ((($Configuration eq $config) || ( $allconfig)) && ($pform !~ /win64/i)){
				printlog("\nConfiguration = $PConfiguration",$printmode,1);
  				Process90Config();
				$yesconfig++;
				$wrongconf=0;
			}
 	    }
#LINE-end
     } 
	close PROJFILE;
	close TMPFILE;
}
#3.1---------
sub Process90Config {
$done=0;
$DebugSymbols=1;
$DebugType=1;
$er90=0;
    LINE: while(<PROJFILE>) {
	if (m/\/PropertyGroup/) {
		$done=1;
	}
        if (m/DebugSymbols/){
		$DebugSymbols=0;
	    if(!m/true/i ) {
		$er90++;
		m/(.*)>(.*)<(.*)/;
			$info ="$1>true<$3";
           		print TMPFILE "$info\n";
	    }else{
            		print TMPFILE "$_";
	    }
	}elsif (m/DebugType/){
		$DebugType=0;
	    if(!m/full/i  && !m/pdb-only/i) {
		$er90++;
		m/(.*)>(.*)<(.*)/;
			$info ="$1>full<$3";
           		print TMPFILE "$info\n";
	    }else{
            		print TMPFILE "$_";
	    }
	}else{
		if (!$done){ 
           	print TMPFILE "$_";
	     }

	}
	if ($done){
#add missed line
		if ($DebugSymbols){
			$er90++;
			$info="    <DebugSymbols>true</DebugSymbols>";
          		print TMPFILE "$info\n";
		}
		if ($DebugType){
			$er90++;
			$info="    <DebugType>full</DebugType>";
          		print TMPFILE "$info\n";
		}
		if ($er90){
			$error++;
 			if ( $ptype =~ m/vbproj/i){
				printlog("Incorrect Setting: Generate Debug Info needs to be set to pdb-only or Full in Advanced Compile Options section of Compile Properties",$printmode,1);
			}else {
				printlog("Incorrect Setting: Debug Info needs to be set to pdb-only or Full in Advanced section of Build Configuration Properties",$printmode,1);
			}
		}
		print TMPFILE "$_";
		last LINE;
    	}
     }
}

#4---------Scan Skip project ------------------------------
sub skipproj 
{
 	printlog("\n--------------------------------------------------",$printmode,1);
	printlog("Project name = $BackupProj",$printmode,1);
	printlog("Project file = $fname",$printmode,2);
#	printlog("ProjectType = $ProjType Version = $projversion ",$printmode,1);
#	open(PROJFILE, $fname)  || die printlog("Cannot open project file $fname: $!", $printmode, 1,1,1); 
#	close PROJFILE;
	printlog("\nSettings not checked for this project.",$printmode,1);
}

#5---------Common routine ------------------------------
sub printlog()
{
	my ($printstr, $pmode, $lf, $sout,$end)=@_;
#$printstr=print string
#$pmode= printmode 0=console, 1=output-file
#$lf=linefeed,
#$sout=stand output also, 0=no, 1=yes
#$end=end of program 1=end
	if ($pmode) {
		print OUTFILE $printstr;
		for ($i=1; $i<=$lf; $i++){
			print OUTFILE "\n";
		}
		if($sout){
			print $printstr;
			for ($i=1; $i<=$lf; $i++){
			print "\n";
			}
		}
	}else{
		print $printstr;
		for ($i=1; $i<=$lf; $i++){
			print "\n";
		}
	}
	if ($end){
		if (-e "$tempfile"){
			close TMPFILE;
 			 `del $tempfile `;
		}
		exit 1;
	}

}
sub Usage()
{
	print "$cmdversion Usage:\n";
	print "perl $0 [<options>] \n";
	print "Options:\n";
	print " -sln=<solution-file> ==> specify the solution file to check or modify.\n";
	print "                          You must specify a solution file or a project file.\n";
	print " -proj=<project-file> ==> specify the project file to check or modify\n";
	print " -config=<ConfigurationName | all>\n";
	print "       config=ConfigurationName  ===> only scan the specified configuration\n";
	print "       config=all (default) ==> scan all configurations\n";
	print " -report=<output file> Specify the output file\n";
	print "       (default)=output to console\n";
	print " -write=<yes> Modify settings and write. \n";
	print "        It is recommended that you backup the projects before modifying.\n";
	print "        write=yes ==> modify settings and write project file(s) after\n";
	print "                      saving current project file(s) to <projectFile>.backup.\n";
	print "        write=no (default)==> report incorrect settings only, \n";
	print "                              don't modify anything.\n";
	print "e.g. perl $0 -sln=\"C:\\My Apps\\MyCode.sln\" -report=scan.log -write=yes\n";
	print "or   perl $0 -proj=C:\\MyApps\\Myproj.vcproj -report=scan.log -write=yes\n";
	exit 1;
}

__END__

